function createOverride
{
    param($monitorName, $overrideMp, $parameter, $overrideValue)
    $Monitors =  Get-SCOMMonitor -Name $monitorName
    #write-host $Monitors[0].Name
    monitorConfigurationOverride -overrideMp $overrideMp -Monitor $Monitors[0] -parameter $parameter -overrideValue $overrideValue
    monitorPropertyOverride -overrideMp $overrideMp -Monitor $Monitors[0] -parameter 'Enabled' -overrideValue 'false'
    
}

function monitorConfigurationOverride
{
    param($overrideMp, $Monitor, $parameter, $overrideValue)
    $Target = Get-SCOMClass -Name "Microsoft.SystemCenter.Agent"
    $overrideName = $Monitor.name+"."+"$parameter"+"Value.Override"
    $override = New-Object Microsoft.EnterpriseManagement.Configuration.ManagementPackMonitorConfigurationOverride($overrideMp, $overrideName)             
    $override.Monitor = $Monitor
    $Override.Parameter = $parameter
    $override.Value = $overrideValue
    $override.Context = $Target
    #$override.DisplayName = $overrideName
    #write-host $override
    $overrideMp.Verify()
    $overrideMp.AcceptChanges()
 }

 function monitorPropertyOverride
{
    param($overrideMp, $Monitor, $parameter, $overrideValue)
    $Target = Get-SCOMClass -Name "Microsoft.SystemCenter.Agent"
    $overrideName = $Monitor.name+"."+"$parameter"+"Value.Override"
    $override = New-Object Microsoft.EnterpriseManagement.Configuration.ManagementPackMonitorPropertyOverride($overrideMp, $overrideName)             
    $override.Monitor = $Monitor
    $Override.Property = $parameter
    $override.Value = $overrideValue
    $override.Context = $Target
    #$override.DisplayName = $overrideName
    #write-host $override
    $overrideMp.Verify()
    $overrideMp.AcceptChanges()
 }
try
{
Import-module operationsmanager
#$msObj = Get-SCOMManagementServer | Select-Object DisplayName
#write-host $msObj.DisplayName
#$ms = $msObj.DisplayName
$mpID = "Dell.AgentResource.Override"

$mg = new-object Microsoft.EnterpriseManagement.ManagementGroup "localhost"

#$mg = New-Object Microsoft.EnterpriseManagement.ManagementGroup($ms)
$mpStore = New-Object Microsoft.EnterpriseManagement.Configuration.IO.ManagementPackFileStore
$overrideMp = New-Object Microsoft.EnterpriseManagement.Configuration.ManagementPack($mpID, $mpID, (New-Object Version(1, 0, 0)), $mpStore)
#write-host $overrideMp

createOverride -monitorName "Microsoft.SystemCenter.Agent.HealthService.HandleCountThreshold" -overrideMp $overrideMp -parameter 'Threshold' -overrideValue 30000
createOverride -monitorName "Microsoft.SystemCenter.Agent.HealthService.PrivateBytesThreshold" -overrideMp $overrideMp -parameter 'Threshold' -overrideValue 1610612736
createOverride -monitorName "Microsoft.SystemCenter.Agent.MonitoringHost.HandleCountThreshold" -overrideMp $overrideMp -parameter 'Threshold' -overrideValue 30000
createOverride -monitorName "Microsoft.SystemCenter.Agent.MonitoringHost.PrivateBytesThreshold" -overrideMp $overrideMp -parameter 'Threshold' -overrideValue 1610612736

$mg.ImportManagementPack($overrideMp)
return "SUCCESS";
}
catch [Exception]
 {
   return "FAIL";
 }