param(
		[string]$mgName
	 )

function createCipherTextObject($AESKey, $IV) {
	$AESBased = New-Object System.Security.Cryptography.AesManaged
	$AESBased.Mode = [System.Security.Cryptography.CipherMode]::CBC
	$AESBased.Padding = [System.Security.Cryptography.PaddingMode]::PKCS7
	$AESBased.BlockSize = 128
	$AESBased.KeySize = 256
	$AESBased.FeedbackSize = 32
	if ($IV) {
		if ($IV.getType().Name -eq "String") {
			$AESBased.IV = [System.Convert]::FromBase64String($IV)
		}
		else {
			$AESBased.IV = $IV
		}
	}
	if ($AESKey) {
		if ($AESKey.getType().Name -eq "String") {
			$AESBased.Key = [System.Convert]::FromBase64String($AESKey)
		}
		else {
			$AESBased.Key = $AESKey
		}
	}
	$AESBased
}

function generateAESKey($ServiceTag)
{
		$mgNameAsKey = $mgName
		$AESkey = $mgNameAsKey+$ServiceTag
		$AESkey = $AESkey.Replace('.','/')
		$AESkey = $AESkey.Replace('-','+')
		$AESkey = $AESkey.Replace('_','+')
		$AESkey = $AESkey.Replace('@','+')

		$count = $AESkey.Length
		if($count -lt 32)
		{
				$padding = 32 - $count
				#First Pad is / and continued with 0
				$AESkey = $AESkey + "/"
				for($pad =1;$pad -lt $padding;$pad++){
						$AESkey = $AESkey + "0"
				}
		}
		elseif($count -gt 32)
		{
				$AESkey = $AESkey.Substring(0,32)
		}

		$finalKeyLen = $AESkey.Length
		return $AESkey
}

function decryptUsrPswd($AESKey, $encryptedStringWithIV) {
	$bytes = [System.Convert]::FromBase64String($encryptedStringWithIV)
	$IV = $bytes[0..15]
	$AESBased = createCipherTextObject $AESKey $IV
	$decryptor = $AESBased.CreateDecryptor();
	$unencryptedData = $decryptor.TransformFinalBlock($bytes, 16, $bytes.Length - 16);
	$AESBased.Dispose()
	[System.Text.Encoding]::UTF8.GetString($unencryptedData).Trim([char]0)
}

function decryptCommunityString($AESKey, $encryptedStringWithIV) {
        $bytes = [System.Convert]::FromBase64String($encryptedStringWithIV)
        $IV = $bytes[0..15]
        $AESBased = createCipherTextObject $AESKey $IV
        $decryptor = $AESBased.CreateDecryptor();
        $unencryptedData = $decryptor.TransformFinalBlock($bytes, 16, $bytes.Length - 16);
        $AESBased.Dispose()
        [System.Text.Encoding]::UTF8.GetString($unencryptedData).Trim([char]0)
}

try
{

	$strPathToJSON = "\usr\share\tomcatTejas\lclogs\scom\mg\" + $mgName + "\toapp\json"
	$strPathToJSON = $strPathToJSON + "\scomdiscovereddevices.json"

	if (Test-Path -path($strPathToJSON))
	{
		$jsonString = Get-Content $strPathToJSON -Raw
		$jsonObj = [ordered]@{}
		(ConvertFrom-Json $jsonString).psobject.properties | Foreach { $jsonObj[$_.Name] = $_.Value }
		$returnJson = [ordered]@{ discoverymodes = @{}
							  snmpdevices = @{}
							wsmandevices = @{}
						}
		$jsonTemp = @{
			servicetag = ""
			ip = ""
			username = ""
			password = ""
			portnumber = ""
		}
		$jsonTempCMC = @{
			ip = ""
			communitystring = ""
			snmpversion = ""
			devicekey = ""
			portnumber = ""
			username = ""
			password = ""
		}
		if($jsonObj.discoverymodes -ne $null)
		{
			foreach($device in $jsonObj.discoverymodes)
			{
				$Chassis = $device.'Chassis Monitoring'
				$Server = $device.'Server and rack workstation monitoring (licensed)'
				if($Chassis -ne $null)
				{
					$htdiscoverymodes = $returnJson.discoverymodes + [ordered]@{ "Chassis Monitoring"= $Chassis}
					$returnJson.discoverymodes = $htdiscoverymodes
				}
				if($Server -ne $null)
				{
					$htdiscoverymodes =$returnJson.discoverymodes + [ordered]@{ "Server and rack workstation monitoring (licensed)"= $Server}
					$returnJson.discoverymodes = $htdiscoverymodes
				}
			}
			
		}
		if($jsonObj.snmpdevices -ne $null)
		{
			foreach($device in $jsonObj.snmpdevices)
			{
				$IPAddress = $device.ip
				$encryptedCommunityString = $device.communitystring
				$snmpversion = $device.snmpversion
				$deviceKey = $device.devicekey
				$portnumber = $device.portnumber
				$username = $device.username
				$encryptedPasswordCMC = $device.password

				if($IPAddress -ne $null)
				{
					if(($encryptedPasswordCMC.Length -gt 0) -and ($username.Length -gt 0))
					{
						$AESKeyCMC = generateAESKey $IPAddress
						$deCryptedPasswordCMC = decryptUsrPswd $AESKeyCMC $encryptedPasswordCMC
						$deCryptedCommunityString = decryptCommunityString $AESKeyCMC $encryptedCommunityString
						$jsonTempCMC = $stjsonTemp.snmpdevices + @([ordered]@{ip = $IPAddress; communitystring = $deCryptedCommunityString; snmpversion = $snmpversion; devicekey = $DeviceKey; portnumber = $portnumber; username = $username; password = $deCryptedPasswordCMC})
						$stjsonTemp = [ordered]@{"snmpdevices" = @($jsonTempCMC)}
						$returnJson.snmpdevices = $stjsonTemp.snmpdevices
					}
					else
					{
						$AESKeyCMC = generateAESKey $IPAddress
						$deCryptedCommunityString = decryptCommunityString $AESKeyCMC $encryptedCommunityString
						$jsonTempCMC = $stjsonTemp.snmpdevices + @([ordered]@{ip = $IPAddress; communitystring = $deCryptedCommunityString; snmpversion = $snmpversion; devicekey = $DeviceKey; portnumber = $portnumber; username = ""; password = ""})
						$stjsonTemp = [ordered]@{"snmpdevices" = @($jsonTempCMC)}
						$returnJson.snmpdevices = $stjsonTemp.snmpdevices
					}
				}
				else
				{
					continue
				}
			}
		}
		if($jsonObj.wsmandevices -ne $null)
		{
			foreach($device in $jsonObj.wsmandevices)
			{
				$ServiceTag = $device.servicetag
				$ip = $device.ip
				$username = $device.username
				$encryptedPassword = $device.password
				$portnumber = $device.portnumber

				if($ServiceTag -ne $null)
				{
					$AESKey = generateAESKey $ServiceTag
					$deCryptedPassword = decryptUsrPswd $AESKey $encryptedPassword
					$jsonTemp = $stjsonTemp.wsmandevices + @([ordered]@{servicetag = $ServiceTag; ip = $ip;username = $username; password = $deCryptedPassword; portnumber = $portnumber})
					$stjsonTemp = [ordered]@{"wsmandevices" = @($jsonTemp)}
					$returnJson.wsmandevices = $stjsonTemp.wsmandevices
				}
				else
				{
					continue
				}
			}
		}
		$returnToApp = $returnJson | ConvertTo-Json -Compress
		return $returnToApp
	}
	
}
catch [Exception]
{
	return "FAIL"
}
