param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$info)

############### CONSTANTS ###########################

set-variable -name Response_Success -value "SUCCESS" -option constant
set-variable -name Response_FAIL -value "FAIL" -option constant
set-variable -name REPORT_TARGET_FILE_LOCATION -value "\\\\localhost\\UPDATE\\reports\\" -option constant
set-variable -name UPDATE_SHARE -value "\UPDATE\" -option constant

############### CONSTANTS ###########################

# Create Credential obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

$info = $info -replace "\\n\\r", " "
write-output $info

$cred=Createcredobj $DomainUsername $DelPwd
$clusterFQDN=$info.split(",")[0]
$igfqdn=$info.split(",")[1]
$libShareName=$info.split(",")[2]
$jobName=$info.split(",")[3]
$returnval = @()

Write-ouput $jobName

	ipmo ScheduledTasks

    #remove an existing CAU task
	if($jobName -ne 'NULL'){
		Unregister-ScheduledTask -TaskName $jobName -Confirm:$false
		write-host "deleted Windows Task $jobName"
	}
	
if([string]::IsNullorEmpty($clusterFQDN)){
	#throw error if the clusterFQDN is not present
	$returnval = $returnval + $Response_FAIL
	$returnval = $returnval + "Message:Arg clusterFqdNName is null. CleanUp CAU repository Operation Completed Unsuccessfully"
	return $returnval
}

$folderToDelete=Join-Path $libShareName $clusterFQDN
write-host $folderToDelete
$doesExists=Test-Path -path $folderToDelete

if($doesExists -eq $false){
	$returnval = $returnval + $Response_Success
	$returnval = $returnval + "Message:Repository not available. CleanUp CAU repository Operation Completed Successfully"
	return $returnval
}else {
	try{
	#remove the repository
	#Get-ChildItem $folderToDelete -Recurse | Remove-Item -Force 
	Remove-Item $folderToDelete -Recurse -Force

	$nowExists=Test-Path -path $folderToDelete
	
	if($nowExists -eq $true){
		
		$returnval = $returnval + $Response_FAIL
		$returnval = $returnval + "Message:Repository clean up failed. CleanUp CAU repository Operation Completed Unsuccessfully"
		return $returnval
	}else{
	
		$SUUSharePath=Join-Path $libShareName "\SUU_ENGINE\*.cab"
		#remove the SUU and .cab file
		#Get-ChildItem $folderToDelete -Recurse | Remove-Item -Force 
		Remove-Item $SUUSharePath -Recurse -Force
		
		$returnval = $returnval + $Response_Success
		$returnval = $returnval + "Message:Repository clean up successfull. CleanUp CAU repository Operation Completed Successfully"
		return $returnval
	}
	}catch{
		$returnval = $returnval + $Response_FAIL
		$returnval = $returnval + $_.Exception.Message
		return $returnval
	}
}
return $returnval