param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$info)

Function Createcredobj($username, $passwd){
    try{
        $secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch{
        $mycredsobj = $null
    }

    return $mycredsobj
}


$info = $info -replace "\\n\\r", " "


$returnval = @()


$sccmCred= Createcredobj $DomainUsername $DelPwd

try{
        #step 0. Create connection with SCCM machine and get the site code
		$siteCode=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
				Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
				$PSD = Get-PSDrive -PSProvider CMSite
				if($PSD -eq $null){
					New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[0]
					$PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
					$SiteCode= CD "$($PSDN):"
				}else{
                        $SiteCode= CD "$($PSD):" 
                }
                $VMMobj= Get-CMSite
				if ( $VMMobj -ne $null ){
                                             
                    return $VMMobj.SiteCode
                }else{
                    return "Site Code of the SC was not identified"
                }
		}-Args $ComputerName -ErrorVariable errmsg  2>$null
               
		#step 1. Create connection with SCCM machine and pass the site code
		$emsg=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ScriptBlock{
				############### CONSTANTS ###########################
								  
				set-variable -name Response_Success -value "SUCCESS" -option constant
				set-variable -name Response_FAIL -value "FAIL" -option constant
				set-variable -name Exception_Code -value 101 -option constant
				set-variable -name zeroguid -value "00000004-0000-0000-0000-000000000000" -option constant
				set-variable -name collectionNameAllSystems -value "All Systems" -option constant
				set-variable -name osNameVersionIndex -value "0,1,2,3,4,5,6,7,8,9" -option constant
				set-variable -name collectionNameImportDellServers -value "Dell Imported Servers" -option constant
				set-variable -name collectionNameAllDellLCControllers -value "All Dell Lifecycle Controller Servers" -option constant
				set-variable -name collectionCommentImportDellServers -value "All Dell PowerEdge servers discovered using Import Dell PowerEdge servers wizard" -option constant
				set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
				set-variable -name collectionNameRhel -value "managed dell lifecycle controller(rhel)" -option constant
				set-variable -name collectionNameEsxi -value "managed dell lifecycle controller(esxi)" -option constant
				set-variable -name osRhel -value "rhel" -option constant
				set-variable -name osEsxi -value "esxi" -option constant
				set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
				set-variable -name collectionNameOSDeployed -value "Managed Dell Lifecycle Controller(OS Deployed)" -option constant
				set-variable -name collectionNameOSUnknown -value  "Managed Dell Lifecycle Controller(OS Unknown)" -option constant
				set-variable -name collectionCommentOSDeployed -value "All Dell PowerEdge 11G (and above) servers with Configuration Manager Client" -option constant
				set-variable -name collectionCommentOSUnknown -value "All Dell PowerEdge 11G (and above) servers without Configuration Manager Client"-option constant
				set-variable -name collectionCommentESXi -value "All Dell PowerEdge servers running ESXi operating system" -option constant
								  
				############### CONSTANTS ###########################
								  
				$site=$args[3]
				#Step 2. Split the smbios to get the machine information
			    
                		$nonWinCollectionName=$args[2].split(",")[0]
				$nonWinCollectionName= $nonWinCollectionName-replace "0", "("
				$nonWinCollectionName= $nonWinCollectionName-replace "1", ")"
                		$osName=$args[2].split(",")[1]  
				$serviceTag=$args[2].split(",")[2]
				
								  
				#Step 3. Update SMS_R_iDrac 
								  
				$query="Select * from SMS_R_iDRAC where NetbiosName ='$serviceTag'"
				$ns="root\sms\site_$site"
								  
				$responses=Get-WMIObject -Query $query -Namespace $ns
				if($responses -ne $null){
					#the serviceTag exists in iDRAC
					foreach($idrac in $responses){
						$hostname=$idrac.NetbiosName
						$macAddress=$idrac.MACAddresses
						$smbiosguid=$idrac.SMBIOSGUID
						$resId=$idrac.ResourceId
													
                        Try {
							$messagePATH =(Get-ItemProperty -Path 'HKLM:\SOFTWARE\WOW6432Node\Microsoft\SMS\Deployment\Dell\DLCI' -Name "Installation Directory")."Installation Directory"
							write-host "Installtion Path: " $messagePATH
						}
						Catch [System.Management.Automation.PSArgumentException]
						{}													
						#new approach to create the DDR
						$messageDLLFullPath= join-path $messagePATH "Microsoft.ConfigurationManagement.Messaging.dll"
						Add-Type -Path $messageDLLFullPath
						
						$key=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Key
						$array=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Array
						$none=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::None
						$name=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Name
																
						$ddrFile2=new-object -TypeName Microsoft.ConfigurationManagement.Messaging.Messages.Server.DiscoveryDataRecordFile("customAgent")
																
						$ddrFile2.SiteCode=$site
						$ddrFile2.Architecture='iDRAC'
						$ddrFile2.Trusted="true"
						$ddrFile2.IsSigned="true"
																
						$ddrFile2.AddStringProperty("Netbios Name",$key,64,$hostname)
						$ddrFile2.AddStringPropertyArray("MAC Addresses",$array -or $key,64,$macAddress)
						$ddrFile2.AddStringProperty("OSName",$none,64,$osName)
																
						#Get the DDR Path from WMI
						$ddrInboxPath=""
						$getDDRQuery="SELECT DDRPath from SMS_Dell_OOBConfig_Settings WHERE ResourceID=1"
						$resultsGetDDR=Get-WMIObject -Query $getDDRQuery -Namespace "root\cimv2\dlci"
							   
					
						if($resultsGetDDR -ne $null){
							foreach($resultGetDDR in $resultsGetDDR){
							$ddrInboxPath=$resultGetDDR.DDRPath
							}
						}
							   
						if($ddrInboxPath.Length -eq 0){
																			   
							$ddrInboxPath =$ddrInboxPath+ "\\{0}"
						}
																
						$fileddrPath= join-path $ddrInboxPath $idracOutDdrName
																											 
																																																	   
						#save the DDR to the Path
						#$wassecondddr=$SMSDisc.DDRWrite($desktopPath)
						$tmp=[System.IO.Path]::GetTempPath()
						$tempDDR=$ddrFile2.SerializeToFile($tmp)
						#write-host "tempDDR2: " + $tempDDR
						if([string]::IsNullorEmpty($tempDDR)){
							return "State:$response_FAIL,Message:Failed to create iDRAC DDR"
						}else{
							#validating the path returned from $tempDDR
							#test if the file exists
							if(Test-Path $tempDDR){
								#check the size of file
								if((Get-Item $tempDDR).Length -eq '0'){
									return "State:$response_FAIL,Message:Empty iDRAC DDR created"
								}
							}else{
									return "State:$response_FAIL,Message:Failed to create iDRAC DDR"
							}
						}						
						#now copy this DDR file to your SCCM Server DDM.Box inbox 
						Copy-Item -path $tempDDR -Destination $fileddrPath
					
						if(Test-Path $tempDDR){              
							[System.IO.File]::Delete($tempDDR)
	 
						}else{
							return "Status:$Response_FAIL,Message:The machine does not exist in SMS_R_iDRAC"
						}
					}
				}
                              
                #Step 4. Create non Windows OS Collection 
                #check if the Non Win OS exists collection exist         
                $queryString="Select * from SMS_Collection WHERE Name='$nonWinCollectionName'"
                $collResult=Get-WMIObject -Query $queryString -Namespace $ns
                              
                if($collResult -ne $null){
                    #Collection exist, Do Nothing 
                                             
                }else{
                    #Collection does not exist, Create the collection
                    #check if All Dell Lc Collection Exist
                    $queryString="Select * from SMS_Collection WHERE Name='$collectionNameAllDellLCControllers'"
                    $collResult=Get-WMIObject -Query $queryString -Namespace $ns
                                             
                    if($collResult -ne $null){
                        foreach($row in $collResult){
                            $parentColl=$row.CollectionID
                        }
                                                            
                        if(![string]::IsNullorEmpty($parentColl)){
                            #Create collection Non Win Os
                            $limitToCollectionID="SMS00001"
                            $ownedByThisSite=$true
                            $query="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_iDRAC.OSName like '$osName'"
                            $ruleName= "DLCI_ $osName _OS_Rule"
                            $ruleName= $ruleName -replace " ", ""
                            $validateQuery=$true
                                                                           
                            #create new SMS_Collection object
                            $CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
                            $CMCollection.Name=$nonWinCollectionName
                            $CMCollection.Comment=$collectionCommentESXi
                            $CMCollection.OwnedByThisSite=$ownedByThisSite
                            $CMCollection.LimitToCollectionID=$limitToCollectionID
                            $didCommit=$CMCollection.Put()
                            $get1= $CMCollection.Get()
                                                                           
                            #validate
                            if($validateQuery -eq $true){
                                #Validate Query syntax  
                                $ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $query
                                if($ValidatingQuery -eq $null){
                                    return "Status:$response_FAIL,Message:Validation of query failed"
                                }
                            }
                                                                           
                            #create new Query Rule 
                            $NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
                            $NewRule.QueryExpression=$query
                            $NewRule.RuleName=$ruleName         
                            $CMCollection.CollectionRules+= $NewRule.psobject.baseobject
                    
							$put= $CMCollection.Put()
							$refresh= $CMCollection.RequestRefresh()
                                                                           
                                                                           
                        }
                    }else{
                        #The All Dell LC Collection does not exist
                        $retCode = $false
                        $parentColl = ""
                        $queryString = "Select * from SMS_R_iDRAC"
                        $collFound = $false
                        $MAXRETRIES = 1
                        $ctr = 0
                                                            
                        while($ctr -lt $MAXRETRIES -and $collFound -eq $false){
                            $ctr=$ctr+1                                         
                            $result=Get-WMIObject -Query $queryString -Namespace $ns
                                                                                                               
                            if($result -ne $null)
                            {
                                $collFound = $true
                            }
                                                                           
                            if($collFound -eq $true) {							
								#CreateDynamicCollectionForSCCM2012
								$limitToCollectionID="SMS00001"
								$ownedByThisSite=$true
								$query="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME)"
								$ruleName= "11G_Parent_Rule"
								$validateQuery=$true
																			   
								#create new SMS_Collection object
								$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
								$CMCollection.Name=$collectionNameAllDellLCControllers
								$CMCollection.Comment=$collectionCommentAllDellLCControllers
								$CMCollection.OwnedByThisSite=$ownedByThisSite
								$CMCollection.LimitToCollectionID=$limitToCollectionID
								$didCommit=$CMCollection.Put()
								$get1= $CMCollection.Get()
											  
																	
								#validate
								if($validateQuery -eq $true){
									#Validate Query syntax  
									$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $query
									if($ValidatingQuery -eq $null){
										return "Status:$response_FAIL,Message:Validation of query failed"
									}
								}
																			   
								#create new Query Rule 
								$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
								$NewRule.QueryExpression=$query
								$NewRule.RuleName=$ruleName
																			   
								$CMCollection.CollectionRules+= $NewRule.psobject.baseobject
						
								$put= $CMCollection.Put()
								$refresh= $CMCollection.RequestRefresh()
								$retCode=$true
																			   
								if($retCode -eq $true){
									#Create collection Non Win Os
									$limitToCollectionID="SMS00001"
									$ownedByThisSite=$true
									$query="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_iDRAC.OSName like '$osName'"
									$ruleName= "DLCI_ $osName _OS_Rule"
                            					$ruleName= $ruleName -replace " ", ""
									$validateQuery=$true
																							  
									#create new SMS_Collection object
									$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
									$CMCollection.Name=$nonWinCollectionName
									$CMCollection.Comment=$collectionCommentESXi
									$CMCollection.OwnedByThisSite=$ownedByThisSite
									$CMCollection.LimitToCollectionID=$limitToCollectionID
									$didCommit=$CMCollection.Put()
									$get1= $CMCollection.Get()
																							  
									#validate
									if($validateQuery -eq $true){
										#Validate Query syntax  
										$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $query
										if($ValidatingQuery -eq $null){
											return "Status:$response_FAIL,Message:Validation of query failed"
										}
									}
																							  
									#create new Query Rule 
									$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
									$NewRule.QueryExpression=$query
									$NewRule.RuleName=$ruleName
																																  
									$CMCollection.CollectionRules+= $NewRule.psobject.baseobject                                      
									$put= $CMCollection.Put()
									$refresh= $CMCollection.RequestRefresh()
								}
							}
                        }
                    }
				}
                              
                              
		}-Args $DomainUsername,$ComputerName,$info,$siteCode -ErrorVariable errmsg  2>$null
               
    if($emsg -match "FAIL"){
        $returnval=$returnval+"FAIL"
        $returnval=$returnval+$emsg
        return $returnval
    }else{
               
        $returnval=$returnval+"SUCCESS"
        $returnval=$returnval+"DDR created successfully"
        return $returnval
    }
}catch{
    $returnval=$returnval+"FAIL"
    $returnval=$returnval+$_.Exception.Message
    return $returnval
}

