param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$hostProfileName)

## This script gets the logical network details from scvmm
$debug1 = 1
#Import-Module -Name "virtualmachinemanager"

# Return Value
$returnval = @()
  
#$DelUserName='tejas\administrator'
#$DelPwd='Dell_123$'
#$VMMServer='scvmm.tejas.com'

#$hostProfileName = @("test_4c4c4544-0039-4810-8051-b2c04f383253")

$hostProfileName = $hostProfileName -replace "\\n\\r", " "	


# Create obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

#import SCVMM related cmdlets
import-module virtualmachinemanager

# Create SCVMM Cred obj    
    $scvmmcreds = Createcredobj $DomainUsername $DelPwd
    if ( $scvmmcreds -eq $null)
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + "Could not create credentail object for the given SCVMM user"
        return $returnval
    }

# A user can have mutiple role, in Tejasconext we are connecting always as DelegatedAdmin Role.

    try 
    {
        $VMMobj = Get-SCVMMServer -ComputerName $ComputerName -Credential $scvmmcreds 
    }
    catch [exception]
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + $Error[0].Exception
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
    }

    if ( $VMMobj -eq $null)
    {
        $returnval = $returnval + "FAIL"
        $returnval = $returnval + "Could not connect to SCVMM, host not reachable"
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
       
    }
	else
    {
		
		try
		{
			# get library server
            $ErrorActionPreference = "Stop";
            # Get the host profile   
            $hostProfile = (Get-SCPhysicalComputerProfile -Name $hostProfileName -VMMServer $VMMobj)

            # No Host profile found
			if ($hostProfile -eq $null)
			{
				    $returnval = $returnval + "SUCCESS"
				    $returnval = $returnval + "Host profile $hostProfileName does not exist, No need to delete"
					

				    if ($debug1 -eq 0)
				    {
					    write-host $returnval
				    }
				    return $returnval
				
			}
			else # Found host profile
			{
				if ($debug1 -eq 0)
				{
					write-host "Host profile found"
				}
               
                Remove-SCVMHostProfile -VMHostProfile $hostProfile -Force | Out-Null
                               
				
                $returnval = $returnval + "SUCCESS"
				$returnval = $returnval + "Deleted host profile $hostProfileName successfully"
				

				if ($debug1 -eq 0)
				{
					write-host $returnval
				}
				return $returnval
			}

		}
		catch [exception]
		{
				$returnval = $returnval + "FAIL"
			    $returnval = $returnval + "Exception occured while deleting host profile $hostProfileName"
								

				if ($debug1 -eq 0)
				{
					write-host $returnval
				}
				return $returnval
		}

}