param
(
    [string]$componentHash
)
try
{
    Write-Host $componentHash
    if($componentHash.Contains(";"))
    {
        $componentHashAr = $componentHash.split(";")
    }
    else
    {
        $componentHashAr = @($componentHash)
    }
    Write-Host $componentHashAr.Length
    For($i=0;$i -lt $componentHashAr.Length;$i++)
    {
        Write-Host $componentHashAr
        $components = $componentHashAr.Get($i).split(",")
        Write-Host "ETC:" $components.length
        if($components.length -eq 4)
        { 
            $EventID = $components.Get(0)
            Write-Host $EventID
            $HealthStatus = $components.Get(1)
            $ComponentID = $components.Get(2)
            $ServerIDParam = $components.Get(3)
            $EventType = "Warning"
            if([System.Diagnostics.EventLog]::SourceExists("Dell Appliance") -eq $false)
            {
                New-EventLog -Source "Dell Appliance" -LogName "Operations Manager"
            }
            if($HealthStatus -eq "Critical")
            {
                $EventType = "Error"
            }
            elseif (($HealthStatus -eq "Warning") -or ($HealthStatus -eq "Unknown"))
            {
                $EventType = "Warning"
            }
            elseif ($HealthStatus -eq "Healthy")
            {
                $EventType = "Information"
            }
            else
            {
                Continue
            }
            $AlertMessage = $HealthStatus + "\" + $ComponentID + "\" + $ServerIDParam 
            Write-Host $AlertMessage    
            Write-EventLog -LogName "Operations Manager" -Source "Dell Appliance" -EventID $EventID -EntryType $EventType  -Message $AlertMessage  
    
            sleep 3
        }
        else
        {
           return "FAIL";
        }
    }
}
catch [Exception]
{
    return "FAIL";
}
