param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$info)
#$info="\\config1vmm.tejd.bdcsv.lab\UPDATE\SUU_ENGINE\*.cab,r630autoclus.tejd.bdcsv.lab,\\config1vmm.tejd.bdcsv.lab\UPDATE\r630autoclus.tejd.bdcsv.lab\CAU_Updates\CAUHotfix_All"
#$DomainUsername="tejd\jayanth"
#$DelPwd="Dell_123"
############### CONSTANTS ###########################

set-variable -name Response_Success -value "SUCCESS" -option constant
set-variable -name Response_FAIL -value "FAIL" -option constant

############### CONSTANTS ###########################

$info = $info -replace "\\n\\r", " "
$cabFile=$info.split(",")[0]
$clusterFQDN=$info.split(",")[1]                                                           
$cabFileDestination=$info.split(",")[2]
$sharePath=$info.split(",")[3]

# Create Credential obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

Function createSUUDirectory ($directoryPathTobeDeleted,$directoryPathTobeCreated,$cred){
	#if the directoryPathTobeDeleted exists delete it
	$isexists=Test-Path -path $directoryPathTobeDeleted
	write-host "if the directoryPathTobeDeleted exists delete it : "+$isexists
	
	if($isexists -eq $true){
		#remove the path 
		#Get-ChildItem $directoryPathTobeDeleted -Recurse | Remove-Item -Force
		Remove-Item -path $directoryPathTobeDeleted -recurse -Force
	}
	
	#Create new Directory
	$alreadyexist=Test-Path -path $directoryPathTobeCreated
	Write-host "Test if the path to be created exists : "+$alreadyexist
	
	if($alreadyexist -eq $true){
		#Get-ChildItem $directoryPathTobeCreated -Recurse | Remove-Item -Force
		Remove-Item -path $directoryPathTobeCreated -recurse -Force 
	}
	write-host "Craeting the folder "
	$user=whoami
	write-host "user: "$user
	write-host "using new-item" 
	New-Item -ItemType directory -path $directoryPathTobeCreated -Force
	$isCreated= Test-Path -path $directoryPathTobeCreated
	 if($isCreated -eq $false){
		write-output "using md"
		md $directoryPathTobeCreated
		
		$isCreated= Test-Path -path $directoryPathTobeCreated
		
		if($isCreated -eq $false){
			 write-host "using com object "
			 $fso = new-object -ComObject scripting.filesystemobject

			$fso.CreateFolder($directoryPathTobeCreated)
			
			$isCreated= Test-Path -path $directoryPathTobeCreated
			
			if($isCreated -eq $false){
				write-host "using CreateDirectory"
				
				[system.io.directory]::CreateDirectory($directoryPathTobeCreated)
			}
		}
	 }
	
	$isCreated= Test-Path -path $directoryPathTobeCreated
	write-host "was the folder created: "+ $isCreated
	return $isCreated
}

## This script expands SUU.cab to the specified dir 

$debug1 = 1
#$cabFile1="\\localhost\UPDATE\SUU_ENGINE\SUU_753.cab"
#$destinationDir1="\\localhost\UPDATE\suuRepo"
# Return Value
$returnval = @()
#taking the scvmm Library Share directory as the share root path
#$LibSharePath=Get-ItemProperty -Path "HKLM:\Software\Microsoft\Microsoft System Center Virtual Machine Manager Server\Settings\Library"

#$VGSharePath=$LibSharePath.LibrarySharePath
#$shareName=$LibSharePath.LibraryShareName
	try
	{	
		$cred=Createcredobj $DomainUsername $DelPwd
		$directoryPathTobeDeleted=Join-Path $sharePath $clusterFQDN
		$directoryPathTobeCreated=$cabFileDestination
		
		write-host "Deleting the folder : "+$directoryPathTobeDeleted
		write-host "Creating the folder : "+$directoryPathTobeCreated
		
		$firstResponse=createSUUDirectory $directoryPathTobeDeleted $directoryPathTobeCreated $cred
		
		if($firstResponse -eq $false){
			$returnval=$returnval+$Response_FAIL
			$returnval=$returnval+"Message:Failed to create repository structure for cab file expansion"
		}
		
		$result = expand $cabFile -F:* $cabFileDestination
#write-output $result
		
		
		#the $? returns true is the last command was successfull, else false		
		if ($?)
		{
			$returnval = $returnval + $Response_Success
			$returnval = $returnval + " Cab file expantion Operation Completed Successfully"
		}else
		{
			$returnval = $returnval + $Response_FAIL
			$returnval = $returnval + " Cab file expantion Operation Completed Unsuccessfully"
		}		
		if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		
		write-host "setting the SMB configurations"
		Remove-SmbShare -Name OMIMSSC_UPDATE -Force
		write-host "delted the SMBShare"
		write-host "creating a new smb share"
		New-SmbShare -name OMIMSSC_UPDATE -PATH "C:\ProgramData\OMIMSSC Console extension for SCVMM\OMIMSSC_UPDATE" -FullAccess Everyone|out-null
		write-host "setting the encryptdata policy"
		Set-SmbShare -name OMIMSSC_UPDATE -EncryptData $true -Force
		write-host "setting the reject unencerypted access" 
		Set-SmbServerConfiguration -RejectUnencryptedAccess $false -Force
		
		return $returnval

	}
	catch
	{
			$returnval = $returnval + $Response_FAIL
			$returnval = $returnval + $Error[0].Exception
	}


	return $returnval
