param($VMMServer,$DomainUsername,$DelPwd,$tejasFQDN,$tejasIP)

##################################### FUNCTION ###############################################
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}
##################################### FUNCTION ###############################################

#import SCVMM related cmdlets
import-module virtualmachinemanager
$returnval=@()

# Create SCVMM Cred obj    
try{
    $scvmmcreds = Createcredobj $DomainUsername $DelPwd
    if ( $scvmmcreds -eq $null)
    {
		write-Host "Failed to create credentials"
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + "Status:Could not create credentail object for the given SCVMM user"
        return $returnval
    }
	
	$vmm = Get-SCVMMServer -ComputerName $VMMServer -Credential $scvmmcreds
	if($vmm -eq $null){
		$msg=" Failed to connect to VMM server "+$VMMServer
		write-Host $msg
		throw $msg
	}
	
	write-Host "Successfully conneceted with VMM server "+$VMMServer
	
	#get the Host Groups name
	$allGroups = Get-SCVMHostGroup -VMMServer $vmm
	$groupNames=""
	if($allGroups -ne $null){
		foreach($group in $allGroups){
			$name=$group.Name
			$groupNames=$groupNames+$name+";"
		}
		
		write-Host "Group Names fetched "+$groupNames
		$returnjson="Status:Got The host group names,Groups:"+$groupNames
		$returnval=$returnval+ "SUCCESS"
		$returnval=$returnval+$returnjson

		return $returnval
		
	}else{
		#no host group found
		write-Host "No groups were found"
		$returnjson="Status:Got The host group names,Groups:"+$groupNames
		$returnval=$returnval+ "FAIL"
		$returnval=$returnval+$returnjson

		return $returnval
	}
	
	
}catch{
	write-host "Exception occured while fetching the HostGroup names "+$_.Exception.Message
	$errmsg="Exception Occured"+$_.Exception.Message
	$returnval=$returnval+ "FAIL"
	$returnval=$returnval+$errmsg

    return $returnval
}
