﻿Param([string]$ParamApplianceIP,[string]$Mode, [string]$ParamNFSMPPATH, [string]$ParamMPNameList)
#$ParamMPNameList = @()
                    
$DevicesNameList = $ParamMPNameList.Split(',')
$OMPSInstallKey = "HKLM:\Software\Microsoft\System Center Operations Manager\12\Setup\Powershell\V2"
$regKey = get-item $OMPSInstallKey
$OMPSInstallPath = $regKey.GetValue("InstallDirectory")
$omModule = $OMPSInstallPath + "OperationsManager"
Import-Module -Name $omModule
Import-Module OperationsManager


$val = $null
$val = Get-ItemProperty -Path "HKLM:\SOFTWARE\Dell\Dell Server Management Pack Suites" -Name "CurrentVersion"
if(($val.CurrentVersion -ne 7.1) -or ($val -eq $null))
{
    $Programfilepath = $env:ProgramW6432
    $path = "\Dell Management Packs\Server Mgmt Suite\7.1"
    $path = $Programfilepath + $path
    $HostName = [System.Net.Dns]::GetHostEntry([string]$env:computername).HostName

    New-Item -Path HKLM:\Software -Name "Dell" –Force 
    New-Item -Path HKLM:\Software\Dell -Name "Dell Server Management Pack Suites" –Force 

    New-ItemProperty -Path "HKLM:\Software\Dell\Dell Server Management Pack Suites" -Name CurrentVersion –Force -Value "7.1" 
    New-ItemProperty -Path "HKLM:\Software\Dell\Dell Server Management Pack Suites" -Name LicenseWebServerURL –Force -Value ""
    New-ItemProperty -Path "HKLM:\Software\Dell\Dell Server Management Pack Suites" -Name MSHostName –Force -Value $HostName
    New-ItemProperty -Path "HKLM:\Software\Dell\Dell Server Management Pack Suites" -Name Path –Force -Value $path
    New-ItemProperty -Path "HKLM:\Software\Dell\Dell Server Management Pack Suites" -Name UserName –Force -Value ""

}

$ApplianceIP = $ParamApplianceIP	
$scriptname = "Import_DellManagementPacksLog"
$logLevel = 1
$logDirectory = "DellFeatureMonitoring_Logs"
$MSComputerName = (hostname)
$MPInstallStatus = @{ }
$MPUninstallStatus = @{ }

 $MPNameLocationHashTable = @{"Dell.Connections.HardwareLibrary.mp" = "\Library\";
 "Dell.OperationsLibrary.Common.mp"= "\Library\";
 "Dell.FeatureManagement.Pack.mp" = "\";
 "Dell.Model.Server.mp"= "\Server Monitoring\";
 "Dell.OperationsLibrary.Server.mp"= "\Server Monitoring\";
 "Dell.View.Server.mp"= "\Server Monitoring\";
 "Dell.WindowsServer.Scalable.mp"= "\Server Monitoring\";
 "Dell.WindowsServer.InformationAlertsOn" = "\Server Monitoring\";
 "Dell.ManagedServer.Model.mp"= "\Server Monitoring\";
 "Dell.ManagedServer.iSM.mp"= "\Server Monitoring\";
 "Dell.ManagedServer.iSM.Detailed.mp"= "\Server Monitoring\";
 "Dell.Server.OOB.mp" = "\Server Monitoring\";
 "Dell.Server.OOB.DetailedMonitoringOn.mp" = "\Server Monitoring\";
 "Dell.WindowsServer.Detailed.mp" = "\Server Monitoring\";
 "Dell.Server.SDK.mp"= "\Server Monitoring\";
 "Dell.View.SDKServer.mp"= "\Server Monitoring\";
 "Dell.Device.Sync.mp"= "\Server Monitoring\";
 "Dell.Model.CMC.mp"="\Chassis Monitoring\";
 "Dell.OperationsLibrary.CMC.mp"="\Chassis Monitoring\";
 "Dell.View.CMC.mp"="\Chassis Monitoring\";
 "Dell.CMC.OM12.mp"="\Chassis Monitoring\";
 "Dell.Chassis.Detailed.mp"="\Chassis Monitoring\";
 "Dell.View.SDKCMC.mp" = "\Chassis Monitoring\";
 "Dell.CMC.SDK.mp" = "\Chassis Monitoring\";
 "Dell.ChassisModularServer.Correlation.mp" = "\ChassisModularServerCorrelation\";
 "Dell.Server.OpenManage.Dashboard.View.mp" = "\";
 "Dell.CMC.Sync.mp" = "\Chassis Monitoring\";
 "Dell.Group.Creation.xml" = "\";
 "Dell.NetworkSwitch.mp" = "\NetworkSwitch Monitoring\";
 "Dell.View.NetworkSwitch.mp" = "\NetworkSwitch Monitoring\"
  }
      
 $DefaultMPImportList = @("Dell.Connections.HardwareLibrary.mp",
 "Dell.OperationsLibrary.Common.mp",
 "Dell.FeatureManagement.Pack.mp",
 "Dell.Model.Server.mp",
 "Dell.OperationsLibrary.Server.mp",
 "Dell.View.Server.mp",
 "Dell.WindowsServer.Scalable.mp",
 "Dell.WindowsServer.InformationAlertsOn.mp",
 "Dell.ManagedServer.Model.mp",
 "Dell.ManagedServer.iSM.mp",
 "Dell.ManagedServer.iSM.Detailed.mp",
 "Dell.WindowsServer.Detailed.mp",
 "Dell.Server.SDK.mp",
 "Dell.Server.OOB.mp",
 "Dell.Server.OOB.DetailedMonitoringOn.mp",
 "Dell.View.SDKServer.mp",
 "Dell.Model.CMC.mp",
 "Dell.OperationsLibrary.CMC.mp",
 "Dell.View.CMC.mp",
 "Dell.CMC.OM12.mp",
 "Dell.Chassis.Detailed.mp",
 "Dell.CMC.SDK.mp",
 "Dell.View.SDKCMC.mp", 
 "Dell.Device.Sync.mp",
 "Dell.CMC.Sync.mp",
 "Dell.Server.OpenManage.Dashboard.View.mp",
 "Dell.ChassisModularServer.Correlation.mp",
 "Dell.Group.Creation.xml"
  )
    
$DefaultMPDeleteList = @(
"Dell.ManagedServer.iSM.Detailed",
"Dell.ManagedServer.EAPOverride",
"Dell.PreferredMonitoring.ServerList",
"Dell.PreferredMonitoring.TaskTrigger",
"Dell.PreferredMonitoringMethod.Override",
"Dell.UseLicenseTaskMethod.Override",
"Dell.SecureReference.Override",
"Dell.ChassisModularServer.Correlation",
"Dell.Server.OOB.DetailedMonitoringOn",
"Dell.ManagedServer.iSM",
"Dell.Server.OpenManage.Dashboard.View",
"Dell.Server.OOB",
"Dell.WindowsServer.InformationAlertsOn",
"Dell.WindowsServer.Detailed",
"Dell.WindowsServer.Scalable",
"Dell.FeatureManagement.TaskRefresher",
"Dell.FeatureManagement.Override",
"Dell.ManagedServer.Model",
"Dell.View.Server",
"Dell.Device.Sync",
"Dell.CMC.Sync",
"Dell.OperationsLibrary.Server",
"Dell.Model.Server",
"Dell.FeatureManagement.Pack",
"Dell.DRAC.OM07",
"Dell.DRAC.OM12",
"Dell.View.DRAC",
"Dell.OperationsLibrary.DRAC",
"Dell.Model.DRAC",
"Dell.Chassis.Detailed",
"Dell.View.CMC",
"Dell.CMC.OM07",
"Dell.CMC.OM12",
"Dell.View.SDKCMC",
"Dell.CMC.SDK",
"Dell.OperationsLibrary.CMC",
"Dell.View.SDKServer",
"Dell.SDK.ApplianceIP.Override",
"Dell.Server.SDK",
"Dell.Model.CMC",
"Dell.Connections.HardwareLibrary",
"Dell.AgentResource.Override",
"Dell.OperationsLibrary.Common",
"Dell.Group.Creation",
"Dell.View.NetworkSwitch",
"Dell.NetworkSwitch"

 
)


$ServerMPInstallList = @("Dell.Connections.HardwareLibrary.mp","Dell.OperationsLibrary.Common.mp","Dell.Server.SDK.mp","Dell.View.SDKServer.mp","Dell.Device.Sync.mp","Dell.FeatureManagement.Pack.mp","Dell.Server.OpenManage.Dashboard.View.mp","Dell.Group.Creation.xml")

$ChassisMPInstallList = @("Dell.Connections.HardwareLibrary.mp","Dell.OperationsLibrary.Common.mp","Dell.CMC.SDK.mp","Dell.View.SDKCMC.mp","Dell.Model.CMC.mp", "Dell.CMC.Sync.mp","Dell.FeatureManagement.Pack.mp", "Dell.Server.OpenManage.Dashboard.View.mp","Dell.Group.Creation.xml")

$NetworkSwitchMPInstallList = @("Dell.Connections.HardwareLibrary.mp","Dell.OperationsLibrary.Common.mp","Dell.NetworkSwitch.mp","Dell.View.NetworkSwitch.mp","Dell.FeatureManagement.Pack.mp", "Dell.Server.OpenManage.Dashboard.View.mp","Dell.Group.Creation.xml")

#$ServerMPDeleteList = @("Dell.View.SDKServer","Dell.SDK.ApplianceIP.Override","Dell.Server.SDK",,"Dell.Device.Sync","Dell.OperationsLibrary.Common","Dell.Connections.HardwareLibrary")
$ServerMPDeleteList = @("Dell.ChassisModularServer.Correlation","Dell.SDK.ApplianceIP.Override","Dell.View.SDKServer","Dell.Server.SDK","Dell.Device.Sync","Dell.Group.Creation.xml")

#$ChassisMPDeleteList = @( "Dell.View.SDKCMC","Dell.CMC.SDK","Dell.Model.CMC","Dell.CMC.Sync","Dell.Connections.HardwareLibrary","Dell.OperationsLibrary.Common")
$ChassisMPDeleteList = @( "Dell.View.SDKCMC","Dell.CMC.SDK","Dell.CMC.Sync","Dell.Group.Creation.xml")

$NetworkSwitchMPDeleteList = @("Dell.View.NetworkSwitch","Dell.NetworkSwitch")


function CreateDellMPFolder
{
    $Programfilepath = $env:ProgramW6432
    $PathList = @(
    "\Dell Management Packs",
    "\Dell Management Packs\Server Mgmt Suite",
    "\Dell Management Packs\Server Mgmt Suite\7.1"  
    )
    foreach($path in  $PathList)
    {  
        $path = $Programfilepath + $path
        If(!(test-path $path))
        {
            New-Item -ItemType Directory -Force -Path $path
            #psDebugLog -level 1 -message  ("Creating folder : " + $path)
        } 
    }
}

$DetailMPList = @("Dell.ManagedServer.iSM.Detailed.mp", "Dell.WindowsServer.Detailed.mp","Dell.Chassis.Detailed.mp","Dell.Server.OOB.DetailedMonitoringOn.mp")

try
{
	$ErrorActionPreference = "SilentlyContinue"                   
	if ($LogLevel -ne 0) 
	{
		$TempFolder = $env:SystemRoot + "\Temp"
		$LogLocation = $TempFolder + "\" + $logDirectory + "\"
		If(!(Test-Path -path($TempFolder)))
		{
			# create the directory if not present
			New-Item $TempFolder -type directory 
		}
		If(!(Test-Path -path($LogLocation)))
		{
			# create the directory if not present
			New-Item $LogLocation -type directory 
		}
		$Global:LogFileLocation = $LogLocation + $scriptname + ".log"
		If(!(Test-Path -path($LogFileLocation)))
		{
			# create the file if it does not exist
			New-Item $LogFileLocation -type file
		}
		Else
		{
			$logFileSize = Get-ChildItem $LogFileLocation | ForEach-Object {($_.Length/1KB)}
			If ($logFileSize -gt 512)
			{
				# existingLogFile is greater than 512 KB
				$archiveTime = Get-Date -f "yyyy-MM-dd_HH.mm" 
				Rename-Item $LogFileLocation ("ArchivedLog_" + $scriptname + "_" + $archiveTime + ".log")
				New-Item $LogFileLocation -type file
			}                    
		}
	}
}
catch
{
	$ErrorMessage = $_.Exception.Message
	$FailedItem = $_.Exception.ItemName
	$message = "Exception in creating log file. Exception-Message:" + $ErrorMessage + $FailedItem
	$api.LogScriptEvent("EnergyConsmPerformanceUnitMonitor.ps1",1345,0,$message)
}
Function psDebugLog
{
	param($level, $message)
	if (($level -gt 0) -and ($level -le $LogLevel))
	{
		$currentTime = Get-Date -f "yyyy-MM-dd_HH.mm.ss"
		Out-File -FilePath $LogFileLocation -InputObject ($currentTime + " :: " + $message) -Append -EA SilentlyContinue
	}
}						
                         
psDebugLog -level 1 -message  ("----------------------------------------------")
psDebugLog -level 1 -message  ("Begin of " + $scriptname + " script ")
psDebugLog -level 1 -message  ("ComputerName : " + $MSComputerName)
psDebugLog -level 1 -message  ("DellApplianceIP : " + $ApplianceIP)
   
			
function InstallManagementPack($ImportPath)
{
    Import-SCManagementPack $ImportPath -ErrorAction:SilentlyContinue -ErrorVariable v   
    return $v
}

function UninstallManagementPack($MPObject)
{                  
    Remove-SCOMManagementPack -ManagementPack $MPObject -ErrorAction:SilentlyContinue -ErrorVariable v   
    return $v          
}
    
function ImportMP
{
    param($MPName, $ImportPath)         
    psDebugLog -level 1 -message ("Installing MP: " + $MPName)
    $InstallStatus = InstallManagementPack($ImportPath)   
    if($InstallStatus -eq $null -or $InstallStatus.Count -eq 0)
    {       
        $MPInstallStatus.Add($MPName, "Successfully imported")       
        psDebugLog -level 1 -message ($MPName + " successfully imported")
    } 
    else 
    {
        $msg = getExceptionDetails -except $InstallStatus
        if($msg -match "already imported")
        {
            $MPInstallStatus.Add($MPName, " is already imported")
            psDebugLog -level 1 -message ($MPName + " is already imported")
        }
        else 
        {
            #return ("ERROR: There were errors in the command.")
            $MPInstallStatus.Add($MPName, "ERROR: Failed Importing Management Pack " + $MPName + " : " + $msg)
            psDebugLog -level 1 -message ("ERROR: Failed Installing Management Pack " + $MPName + " : " + $msg)
        }
    }
}

#Imports Default List Of MP

function ImportDefaultMPList($NFSMPPATH)
{
    #$NFSMPPATH = $ParamNFSMPPATH    
    foreach($MPName in $DefaultMPImportList)
    {
        $Subfolder = $MPNameLocationHashTable.Item($MPName)
        $MPImportPath = $NFSMPPATH +  $Subfolder + $MPName                   
        psDebugLog -level 1 -message ("Installing MP: " + $MPName)
        if($MPName -eq "Dell.Group.Creation")
        {
            $Chkgroup = chkMPPresence($MPName)
            if($Chkgroup -eq $true)
            {
                psDebugLog -level 1 -message ("Installing MP: " + $MPName)
                $InstallStatus = InstallManagementPack($MPImportPath)
                if($InstallStatus -eq $null -or $InstallStatus.Count -eq 0) 
                {       
                    $MPInstallStatus.Add($MPName, "Successfully imported")       
                    psDebugLog -level 1 -message ($MPName + " successfully imported")
                }
                else 
                {
                    $msg = getExceptionDetails -except $InstallStatus
                    if($msg -match "already imported")
                    {
                        $MPInstallStatus.Add($MPName, " is already imported")
                        psDebugLog -level 1 -message ($MPName + " is already imported")
                    }
                    else 
                    {             
                        $MPInstallStatus.Add($MPName, "ERROR: Failed Importing Management Pack " + $MPName + " : " + $msg)
                        psDebugLog -level 1 -message ("ERROR: Failed Installing Management Pack " + $MPName + " : " + $msg)
                    }
                }
                continue; 
            } 
            else
            {
                psDebugLog -level 1 -message ("Previous Version of detailed monitoring MP: " + $MPName + " is not installed, so not importing " + $MPName)         
                continue; 
            }   
       }  
       if($DetailMPList.Contains($MPName))
       {
            #$MPObject = Get-SCOMManagementPack | where{$_.name -eq $MPName  } 
            $result =   chkMPPresence($MPName.Replace(".mp",""))         
            if($result -eq $true)
            { 
                $result
                psDebugLog -level 1 -message ("Installing MP: " + $MPName)
                $InstallStatus = InstallManagementPack($MPImportPath) 
                if($InstallStatus -eq $null -or $InstallStatus.Count -eq 0) 
                {       
                    $MPInstallStatus.Add($MPName, "Successfully imported")       
                    psDebugLog -level 1 -message ($MPName + " successfully imported")
                }
                else 
                {
                    $msg = getExceptionDetails -except $InstallStatus
                    if ($msg -match "already imported")
                    {
                        $MPInstallStatus.Add($MPName, " is already imported")
                        psDebugLog -level 1 -message ($MPName + " is already imported")
                    }
                    else 
                    {             
                        $MPInstallStatus.Add($MPName, "ERROR: Failed Importing Management Pack " + $MPName + " : " + $msg)
                        psDebugLog -level 1 -message ("ERROR: Failed Installing Management Pack " + $MPName + " : " + $msg)
                    }
                }
                continue; 
            } 
            else
            {
                psDebugLog -level 1 -message ("Previous Version of detailed monitoring MP: " + $MPName + " is not installed, so not importing " + $MPName)         
                continue; 
            }   
        }       
        psDebugLog -level 1 -message ("Installing MP: " + $MPName)
        if($MPName -eq "Dell.Server.OOB.mp")
        {
            $chkOOBPresent = chkMPPresence("Dell.Server.OOB")
		    if($chkOOBPresent -eq $true)
		    {
                $InstallStatus = InstallManagementPack($MPImportPath) 
                if($InstallStatus -eq $null -or $InstallStatus.Count -eq 0) 
                {       
                    $MPInstallStatus.Add($MPName, "Successfully imported")       
                    psDebugLog -level 1 -message ($MPName + " successfully imported")
                }
                else 
                {
                    $msg = getExceptionDetails -except $InstallStatus
                    if($msg -match "already imported")
                    {
                        $MPInstallStatus.Add($MPName, " is already imported")
                        psDebugLog -level 1 -message ($MPName + " is already imported")
                    }
                    else 
                    {             
                        $MPInstallStatus.Add($MPName, "ERROR: Failed Importing Management Pack " + $MPName + " : " + $msg)
                        psDebugLog -level 1 -message ("ERROR: Failed Installing Management Pack " + $MPName + " : " + $msg)
                    }
                    continue;
                 }
            }
            else
            {
			    psDebugLog -level 1 -message  ("Previous version of Dell.Server.OOB is not present, Cannot import the Dell Server Out-Of-Band Mps")
                continue;
		    }
        }
        if(($MPName -eq "Dell.CMC.OM12.mp") -or ($MPName -eq "Dell.OperationsLibrary.CMC.mp") -or ($MPName -eq "Dell.View.CMC.mp"))
        {
            $MPID = $MPName.Replace(".mp","")
            $chkMpPresent = chkMPPresence($MPID)
		    if($chkMpPresent -eq $true)
		    {
                $InstallStatus = InstallManagementPack($MPImportPath) 
                if($InstallStatus -eq $null -or $InstallStatus.Count -eq 0) 
                {       
                    $MPInstallStatus.Add($MPName, "Successfully imported")       
                    psDebugLog -level 1 -message ($MPName + " successfully imported")
                }
                else 
                {
                    $msg = getExceptionDetails -except $InstallStatus
                    if($msg -match "already imported")
                    {
                        $MPInstallStatus.Add($MPName, " is already imported")
                        psDebugLog -level 1 -message ($MPName + " is already imported")
                    }
                    else 
                    {             
                        $MPInstallStatus.Add($MPName, "ERROR: Failed Importing Management Pack " + $MPName + " : " + $msg)
                        psDebugLog -level 1 -message ("ERROR: Failed Installing Management Pack " + $MPName + " : " + $msg)
                    }
                }
                continue;
            }
            else
            {
			    psDebugLog -level 1 -message ("CMC MP: " + $MPName + " is not installed, so currently not importing " + $MPName)         
                continue;
		    }

        }
        if($MPName -eq "Dell.WindowsServer.InformationAlertsOn.mp")
        {
            $WindowsInfoAlertsPresent = chkMPPresence("Dell.WindowsServer.InformationAlertsOn")	
		    if($WindowsInfoAlertsPresent -eq $true)	
            {			
		        psDebugLog -level 1 -message  ("Checking Dell Windows Server InformationAlertsOn (In-Band) Mp Presence")	
                $InstallStatus = InstallManagementPack($MPImportPath) 
                if($InstallStatus -eq $null -or $InstallStatus.Count -eq 0) 
                {       
                    $MPInstallStatus.Add($MPName, "Successfully imported")       
                    psDebugLog -level 1 -message ($MPName + " successfully imported")
                }
                else 
                {
                    $msg = getExceptionDetails -except $InstallStatus
                    if($msg -match "already imported")
                    {
                        $MPInstallStatus.Add($MPName, " is already imported")
                        psDebugLog -level 1 -message ($MPName + " is already imported")
                    }
                    else 
                    {             
                        $MPInstallStatus.Add($MPName, "ERROR: Failed Importing Management Pack " + $MPName + " : " + $msg)
                        psDebugLog -level 1 -message ("ERROR: Failed Installing Management Pack " + $MPName + " : " + $msg)
                    }
                }
                continue;
             }
             else
             {
			    psDebugLog -level 1 -message  ("Dell.WindowsServer.InformationAlertsOn is not present, Cannot import the Dell.WindowsServer.InformationAlertsOn Mp")
                continue;
		     }
        }
        $InstallStatus = InstallManagementPack($MPImportPath)             
        if($InstallStatus -eq $null -or $InstallStatus.Count -eq 0) 
        {       
            $MPInstallStatus.Add($MPName, "Successfully imported")       
            psDebugLog -level 1 -message ($MPName + " successfully imported")
        }
        else 
        {
            $msg = getExceptionDetails -except $InstallStatus
            if($msg -match "already imported")
            {
                $MPInstallStatus.Add($MPName, " is already imported")
                psDebugLog -level 1 -message ($MPName + " is already imported")
            }
            else 
            {             
                $MPInstallStatus.Add($MPName, "ERROR: Failed Importing Management Pack " + $MPName + " : " + $msg)
                psDebugLog -level 1 -message ("ERROR: Failed Installing Management Pack " + $MPName + " : " + $msg)
            }
       }
    }
}

#Imports Appliance List Of MP
function ImportMPList($MPNameList, $NFSMPPATH)
{
    $NFSMPPATH = $ParamNFSMPPATH   
    foreach ($MPName in $MPNameList)
    {
        $Subfolder = $MPNameLocationHashTable.Item($MPName )
        $MPImportPath = $NFSMPPATH +  $Subfolder + $MPName             
        # psDebugLog -level 1 -message ("Installing MP: " + $MPName)      
        if($DetailMPList.Contains($MPName))
        {
            $MPObject = Get-SCOMManagementPack | where{$_.name -eq $MPName  } 
            if($MPObject -ne $Null)
            { 
                psDebugLog -level 1 -message ("Installing MP: " + $MPName)
                $InstallStatus = InstallManagementPack($MPImportPath)
                continue;  
            }   
            else
            {
                psDebugLog -level 1 -message ("Previous Version of detailed monitoring MP: " + $MPName + " is not installed, so not importing " + $MPName)         
                continue; 
            }  
 
        } 
        psDebugLog -level 1 -message ("Installing MP: " + $MPName)
        $InstallStatus = InstallManagementPack($MPImportPath)     
        if ($InstallStatus -eq $null -or $InstallStatus.Count -eq 0) 
        {       
            $MPInstallStatus.Add($MPName, "Successfully imported")       
            psDebugLog -level 1 -message ($MPName + " successfully imported")
        }    
        else 
        {
            $msg = getExceptionDetails -except $InstallStatus
            if($msg -match "already imported")
            {
                $MPInstallStatus.Add($MPName, " is already imported")
                psDebugLog -level 1 -message ($MPName + " is already imported")
            }
            else 
            {             
                $MPInstallStatus.Add($MPName, "ERROR: Failed Importing Management Pack " + $MPName + " : " + $msg)
                psDebugLog -level 1 -message ("ERROR: Failed Installing Management Pack " + $MPName + " : " + $msg)
            }
        }
    }
}
###################################################################################################


# -----------------------------------------------------------------------
# Check if MP is present or not and return true/false
# ------------------------------------------------------------------------
Function chkMPPresence($mp_string)
{
    $mpPresent = $false
    Get-SCOMManagementPack | foreach -process{
    if($_.Name -eq $mp_string) 
    {
        $mpPresent = "True"                   
    }
    }
    return $mpPresent
}

#Uninstall Default List Of MP
function UninstallDefaultMPList
{                           
    foreach ($MPName in $DefaultMPDeleteList)
    {            
        $MPObject = Get-SCOMManagementPack | where{$_.name -eq $MPName  } 
        if($MPObject -ne $Null)
        { 
            psDebugLog -level 1 -message ("Uninstalling MP: " + $MPName)         
            $UninstallStatus = UninstallManagementPack($MPObject)     
            if($UninstallStatus -eq $null -or $UninstallStatus.Count -eq 0) 
            {       
                $MPUninstallStatus.Add($MPName, "Successfully Uninstalled")       
                psDebugLog -level 1 -message ($MPName + " Successfully Uninstalled")
            }    
            else 
            {
                $msg = getExceptionDetails -except $UninstallStatus
                if($msg -match "does not exist")
                {
                    $MPUninstallStatus.Add($MPName, " does not exist in SCOM")
                    psDebugLog -level 1 -message ($MPName + " does not exist in SCOM")
                }
                else 
                {             
                    $MPUninstallStatus.Add($MPName, "ERROR: Failed Uninstall Management Pack " + $MPName + " : " + $msg)
                    psDebugLog -level 1 -message ("ERROR: Failed Uninstall Management Pack " + $MPName + " : " + $msg)
                }
            }
        }
    }
}
##############################################################################################################################################
#Uninstall Appliance List Of MP
function UninstallMPList($MPNameList) 
{     
    foreach ($MPName in $MPNameList)
    {  
        $MPObject = Get-SCOMManagementPack | where{$_.name -eq $MPName  } 
        if($MPObject -ne $Null)
        {                 
            psDebugLog -level 1 -message ("Uninstalling MP: " + $MPName)
            $UninstallStatus = UninstallManagementPack($MPObject)     
            if($UninstallStatus -eq $null -or $UninstallStatus.Count -eq 0) 
            {       
                $MPUninstallStatus.Add($MPName, "Successfully Uninstalled")       
                psDebugLog -level 1 -message ($MPName + " Successfully Uninstalled")
            }    
            else 
            {
                $msg = getExceptionDetails -except $UninstallStatus
                if($msg -match "does not exist")
                {
                    $MPUninstallStatus.Add($MPName, " does not exist in SCOM")
                    psDebugLog -level 1 -message ($MPName + " does not exist in SCOM")
                }
                else 
                {             
                    $MPUninstallStatus.Add($MPName, "ERROR: Failed Uninstall Management Pack " + $MPName + " : " + $msg)
                    psDebugLog -level 1 -message ("ERROR: Failed Uninstall Management Pack " + $MPName + " : " + $msg)
                }
            }
        }
    }
	if($Mode -eq "denroll")
	{
		$programPath = $env:ProgramW6432
		$folderPath = "\Dell Management Packs"
		$removeFolder = $programPath + $folderPath
		$delRegEntry = Get-ChildItem -Path Registry::HKEY_LOCAL_MACHINE\SOFTWARE\Dell
		if(Test-Path $removeFolder)
		{
			Remove-Item -Path $removeFolder -Recurse -Force
		}
		if($delRegEntry -ne $null)
		{
			Remove-Item -Path "HKLM:\Software\Dell\Dell Server Management Pack Suites" -Recurse
		    Remove-Item -Path "HKLM:\Software\Dell" -Recurse
		}
	}
}
#Creates Dell.FeatureManagement.Override XML file      
Function CreateFMPHostDiscoveryOverrides
{
    param($outputFilePath, $FMPHostFQDN)		
    $TemplateFMPHostDiscoveryOverride = '
    <ManagementPack ContentReadable="true" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <Manifest>
        <Identity>
            <ID>Dell.FeatureManagement.Override</ID>
            <Version>1.0.0.0</Version>
        </Identity>
        <Name>Dell.FeatureManagement.Override</Name>
        <References>
            <Reference Alias="SystemCenter">
                <ID>Microsoft.SystemCenter.Library</ID>
                <Version>6.1.7221.0</Version>
                <PublicKeyToken>31bf3856ad364e35</PublicKeyToken>
            </Reference>
            <Reference Alias="FeatureManagement">
                <ID>Dell.FeatureManagement.Pack</ID>
                <Version>5.2.0.0</Version>
                <PublicKeyToken>f5205f5754b55108</PublicKeyToken>
            </Reference>
        </References>
    </Manifest>
    <Monitoring>
        <Overrides>
            <DiscoveryPropertyOverride ID="OverridingOf.Dell.FeatureManagement.Enable" Context="SystemCenter!Microsoft.SystemCenter.ManagementServer" Enforced="false" Discovery="FeatureManagement!Dell.FMPHostMgmtServer.Discovery" Property="Enabled">
                <Value>true</Value>
            </DiscoveryPropertyOverride>
            <DiscoveryConfigurationOverride ID="OverridingOf.Dell.FeatureManagement.FQDN" Context="SystemCenter!Microsoft.SystemCenter.ManagementServer" Enforced="false" Discovery="FeatureManagement!Dell.FMPHostMgmtServer.Discovery" Parameter="FMPHostFqdn" Module="FMPHost">
                <Value>FMPHostFQDNHere</Value>
            </DiscoveryConfigurationOverride>
        </Overrides>
    </Monitoring>
    <LanguagePacks>
        <LanguagePack ID="ENU" IsDefault="false">
            <DisplayStrings>
                <DisplayString ElementID="Dell.FeatureManagement.Override">
                    <Name>Dell.FeatureManagement.Override</Name>
                </DisplayString>
            </DisplayStrings>
        </LanguagePack>
    </LanguagePacks>
    </ManagementPack>'
	
	$TemplateFMPHostDiscoveryOverride = $TemplateFMPHostDiscoveryOverride.Replace("FMPHostFQDNHere", $FMPHostFQDN)
	$TemplateFMPHostDiscoveryOverride | Out-File -FilePath ($outputFilePath + "Dell.FeatureManagement.Override.xml")	
}

#Imports Dell.FeatureManagement.Override
Function CreateFMPHostDiscoveryOverride
{
    $FMPHostDiscoveryOverridePresent = chkMPPresence("Dell.FeatureManagement.Override")
    if($FMPHostDiscoveryOverridePresent -eq $false)
    {			
        #$sysinfo = Get-WmiObject -Class Win32_ComputerSystem
        #$localFqdn = "{0}.{1}" -f $sysinfo.Name, $sysinfo.Domain
        $sysinfo = [System.Net.Dns]::GetHostEntry([string]$env:computername)
        $localFqdn = $sysinfo.HostName 
        psDebugLog -level 1 -message  ("Selecting " + $localFqdn + " as FMPHost")			
        CreateFMPHostDiscoveryOverrides -outputFilePath $TempLocation -FMPHostFQDN $localFqdn
        ImportMP -MPName "Dell.FeatureManagement.Override" -ImportPath ($TempLocation + "Dell.FeatureManagement.Override.xml")			
    }
}

Function CreatePreferredMonitoringTriggerOverride
{	
    psDebugLog -level 1 -message "Creating Trigger for Preferred Monitoring"
    $PreferredMonitoringTriggerMP = GetManagementPackByName("Dell.PreferredMonitoring.TaskTrigger")
    if ($PreferredMonitoringTriggerMP -ne $null)
    {
        UninstallManagementPack($PreferredMonitoringTriggerMP)
    }	
    $TempLocation = [environment]::GetEnvironMentVariable("temp","machine") +"\"		
    $PrefIntervalSeconds = (Get-Random -Minimum 84000 -Maximum 90000)			
    $TemplatePreferredMonitoringTriggerOverride = '
	<ManagementPack ContentReadable="true" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	    <Manifest>
		    <Identity>
		        <ID>Dell.PreferredMonitoring.TaskTrigger</ID>
		        <Version>1.0.0.0</Version>
		    </Identity>
	        <Name>Dell.PreferredMonitoring.TaskTrigger</Name>
	        <References>
		        <Reference Alias="OperationsLibrary">
		            <ID>Dell.OperationsLibrary.Server</ID>
		            <Version>6.3.0.13</Version>
		            <PublicKeyToken>f5205f5754b55108</PublicKeyToken>
		        </Reference>
		        <Reference Alias="SystemCenter">
		            <ID>Microsoft.SystemCenter.Library</ID>
		            <Version>7.0.8433.0</Version>
		            <PublicKeyToken>31bf3856ad364e35</PublicKeyToken>
		        </Reference>
	        </References>
        </Manifest>
        <Monitoring>
            <Overrides>
                <DiscoveryConfigurationOverride ID="OverridingOf.Dell.PreferredMonitoring.Interval" Context="SystemCenter!Microsoft.SystemCenter.ManagementServer" Enforced="false" Discovery="OperationsLibrary!Dell.SetPreferredMonitoring.Discovery" Parameter="IntervalSeconds" Module="SPMDiscovery">
                <Value>PrefIntervalSeconds</Value>
                </DiscoveryConfigurationOverride>
            </Overrides>
        </Monitoring>
        <LanguagePacks>
            <LanguagePack ID="ENU" IsDefault="false">
                <DisplayStrings>
                    <DisplayString ElementID="Dell.PreferredMonitoring.TaskTrigger">
                        <Name>Dell.PreferredMonitoring.TaskTrigger</Name>
                    </DisplayString>
                </DisplayStrings>
            </LanguagePack>
        </LanguagePacks>
    </ManagementPack>'
	
    $TemplatePreferredMonitoringTriggerOverride = $TemplatePreferredMonitoringTriggerOverride.Replace("PrefIntervalSeconds", $PrefIntervalSeconds)
	$PreferredMonitoringTriggerMP = $TempLocation + "Dell.PreferredMonitoring.TaskTrigger.xml"
    $TempLocation
	$TemplatePreferredMonitoringTriggerOverride | Out-File -FilePath ($PreferredMonitoringTriggerMP)
	$v = InstallManagementPack($PreferredMonitoringTriggerMP)
	if ($v -eq $null -or $v.Count -eq 0)
	{
	    psDebugLog -level 1 -message ("Success installing Dell.PreferredMonitoring.TaskTrigger")
	}
	else
	{
	    $msg = getExceptionDetails -except $v
	    if ($msg -match "already imported")
	    {
			psDebugLog -level 1 -message ("INFO: Dell.PreferredMonitoring.TaskTrigger is already imported")
	    }
	    elseif($msg -match "timeout period elapsed prior to completion of the operation")
	    {
			psDebugLog -level 1 -message ("ERROR: SCOM Database timeout occurred.  You may need to run the task again.")
	    }
	    else
	    {
			psDebugLog -level 1 -message ("ERROR: There were errors in the command.")
			psDebugLog -level 1 -message ("ERROR: " + $msg)
	    }
    }	
}

Function GetManagementPackByName
{
	param($mpname)
    return (Get-SCManagementPack) | where {$_.Name -eq $mpname}
}

#function UninstallManagementPack($ManagementPack)
#{
    #Remove-SCManagementPack -ManagementPack $ManagementPack -ErrorAction:SilentlyContinue -ErrorVariable v   
    #return $v
#}

#function InstallManagementPack($ImportPath)
#{
    #Install-ManagementPack -filepath $ImportPath -ErrorAction:SilentlyContinue -ErrorVariable v   
    #return $v
#}

#Trigger MP operations Install OR Uninstall
Function TriggerMPOperation()
{
CreateDellMPFolder
#$ParamNFSMPPATH = "C:\Program Files\--Dell Management Packs\Server Mgmt Suite\7.1\*"
$Programfilepath = $env:ProgramW6432
$Destination = $Programfilepath + "\Dell Management Packs\Server Mgmt Suite\7.1"
$ParamNFSMPPATH = $ParamNFSMPPATH +"\*"
Copy-Item $ParamNFSMPPATH $Destination -recurse
$ParamNFSMPPATH = $Destination

    foreach ($DeviceName in $DevicesNameList)
    {         
        if($Mode -eq "denroll")
        {
            UninstallMPList($DefaultMPDeleteList)
        }
        if($Mode -eq "DefaultInstall")
        {
            psDebugLog -level 1 -message  ("Importing Default Management Packs.")
            ImportDefaultMPList -NFSMPPATH $ParamNFSMPPATH
            CreateFMPHostDiscoveryOverride
        }
        if(($Mode -eq "uninstall") -and ($DeviceName -eq "server" ))
        {
            UninstallMPList($ServerMPDeleteList)
        }
        if(($Mode -eq "uninstall") -and ($DeviceName -eq "chassis"))
        {
            UninstallMPList($ChassisMPDeleteList)
        } 
        if(($Mode -eq "uninstall") -and ($DeviceName -eq "networkswitches"))
        {
            UninstallMPList($NetworkSwitchMPDeleteList)
        }            
        if(($Mode -eq "install") -And ($DeviceName -eq "server") )
        {
            psDebugLog -level 1 -message  ("Importing chassis Management Packs.")        
            ImportMPList $ServerMPInstallList $ParamNFSMPPATH
            CreateFMPHostDiscoveryOverride
            #return $MPInstallStatus
        }
        if(($Mode -eq "install") -And ($DeviceName -eq "chassis") )
        {
            psDebugLog -level 1 -message  ("Importing chassis Management Packs.")
            ImportMPList $ChassisMPInstallList $ParamNFSMPPATH
            CreateFMPHostDiscoveryOverride
            # return $MPInstallStatus
        }
         if(($Mode -eq "install") -And ($DeviceName -eq "networkswitches") )
        {
            psDebugLog -level 1 -message  ("Importing NetworkSwitch Management Packs.")        
            ImportMPList $NetworkSwitchMPInstallList $ParamNFSMPPATH
            CreateFMPHostDiscoveryOverride
            #return $MPInstallStatus
        }
        $MPInstallStatus
    }
}
	    
TriggerMPOperation 

#psDebugLog -level 1 -message  ("Checking PreferredMonitoring.ServerList Mp Presence")
#$PreferredServerListpresent = chkMPPresence("Dell.PreferredMonitoring.ServerList")
#if($PreferredServerListpresent -eq $true)
#{
    #$PreferredServerListMP = GetManagementPackByName("Dell.PreferredMonitoring.ServerList")
    #if($PreferredServerListMP -ne $null)
    #{
        #UninstallManagementPack($PreferredServerListMP)
        #psDebugLog -level 1 -message  ("Uninstalling Pref Management Packs.")
    #}
	#psDebugLog -level 1 -message  ("Deleted Dell.PreferredMonitoring.ServerList for upgrade compatibility")
    #CreatePreferredMonitoringTriggerOverride
#}


psDebugLog -level 1 -message  ("End of " + $scriptname + " script ")
psDebugLog -level 1 -message  "----------------------------------------------" 

# SIG # Begin signature block
# MIIYAwYJKoZIhvcNAQcCoIIX9DCCF/ACAQExCzAJBgUrDgMCGgUAMGkGCisGAQQB
# gjcCAQSgWzBZMDQGCisGAQQBgjcCAR4wJgIDAQAABBAfzDtgWUsITrck0sYpfvNR
# AgEAAgEAAgEAAgEAAgEAMCEwCQYFKw4DAhoFAAQU6r4HQrZp8CXbTJJMtlQzk+hD
# I4CgghR9MIIDnzCCAoegAwIBAgIQeaKlhfnRFUIT2bg+9raN7TANBgkqhkiG9w0B
# AQUFADBTMQswCQYDVQQGEwJVUzEXMBUGA1UEChMOVmVyaVNpZ24sIEluYy4xKzAp
# BgNVBAMTIlZlcmlTaWduIFRpbWUgU3RhbXBpbmcgU2VydmljZXMgQ0EwHhcNMTIw
# NTAxMDAwMDAwWhcNMTIxMjMxMjM1OTU5WjBiMQswCQYDVQQGEwJVUzEdMBsGA1UE
# ChMUU3ltYW50ZWMgQ29ycG9yYXRpb24xNDAyBgNVBAMTK1N5bWFudGVjIFRpbWUg
# U3RhbXBpbmcgU2VydmljZXMgU2lnbmVyIC0gRzMwgZ8wDQYJKoZIhvcNAQEBBQAD
# gY0AMIGJAoGBAKlZZnTaPYp9etj89YBEe/5HahRVTlBHC+zT7c72OPdPabmx8LZ4
# ggqMdhZn4gKttw2livYD/GbT/AgtzLVzWXuJ3DNuZlpeUje0YtGSWTUUi0WsWbJN
# JKKYlGhCcp86aOJri54iLfSYTprGr7PkoKs8KL8j4ddypPIQU2eud69RAgMBAAGj
# geMwgeAwDAYDVR0TAQH/BAIwADAzBgNVHR8ELDAqMCigJqAkhiJodHRwOi8vY3Js
# LnZlcmlzaWduLmNvbS90c3MtY2EuY3JsMBYGA1UdJQEB/wQMMAoGCCsGAQUFBwMI
# MDQGCCsGAQUFBwEBBCgwJjAkBggrBgEFBQcwAYYYaHR0cDovL29jc3AudmVyaXNp
# Z24uY29tMA4GA1UdDwEB/wQEAwIHgDAeBgNVHREEFzAVpBMwETEPMA0GA1UEAxMG
# VFNBMS0zMB0GA1UdDgQWBBS0t/GJSSZg52Xqc67c0zjNv1eSbzANBgkqhkiG9w0B
# AQUFAAOCAQEAHpiqJ7d4tQi1yXJtt9/ADpimNcSIydL2bfFLGvvV+S2ZAJ7R55uL
# 4T+9OYAMZs0HvFyYVKaUuhDRTour9W9lzGcJooB8UugOA9ZresYFGOzIrEJ8Byyn
# PQhm3ADt/ZQdc/JymJOxEdaP747qrPSWUQzQjd8xUk9er32nSnXmTs4rnykr589d
# nwN+bid7I61iKWavkugszr2cf9zNFzxDwgk/dUXHnuTXYH+XxuSqx2n1/M10rCyw
# SMFQTnBWHrU1046+se2svf4M7IV91buFZkQZXZ+T64K6Y57TfGH/yBvZI1h/MKNm
# oTkmXpLDPMs3Mvr1o43c1bCj6SU2VdeB+jCCA8QwggMtoAMCAQICEEe/GZXfjVJG
# Q/fbbUgNMaQwDQYJKoZIhvcNAQEFBQAwgYsxCzAJBgNVBAYTAlpBMRUwEwYDVQQI
# EwxXZXN0ZXJuIENhcGUxFDASBgNVBAcTC0R1cmJhbnZpbGxlMQ8wDQYDVQQKEwZU
# aGF3dGUxHTAbBgNVBAsTFFRoYXd0ZSBDZXJ0aWZpY2F0aW9uMR8wHQYDVQQDExZU
# aGF3dGUgVGltZXN0YW1waW5nIENBMB4XDTAzMTIwNDAwMDAwMFoXDTEzMTIwMzIz
# NTk1OVowUzELMAkGA1UEBhMCVVMxFzAVBgNVBAoTDlZlcmlTaWduLCBJbmMuMSsw
# KQYDVQQDEyJWZXJpU2lnbiBUaW1lIFN0YW1waW5nIFNlcnZpY2VzIENBMIIBIjAN
# BgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAqcqypMzNIK8KfYmsh3XwtE7x38EP
# v2dhvaNkHNq7+cozq4QwiVh+jNtr3TaeD7/R7Hjyd6Z+bzy/k68Numj0bJTKvVIt
# q0g99bbVXV8bAp/6L2sepPejmqYayALhf0xS4w5g7EAcfrkN3j/HtN+HvV96ajEu
# A5mBE6hHIM4xcw1XLc14NDOVEpkSud5oL6rm48KKjCrDiyGHZr2DWFdvdb88qiaH
# XcoQFTyfhOpUwQpuxP7FSt25BxGXInzbPifRHnjsnzHJ8eYiGdvEs0dDmhpfoB6Q
# 5F717nzxfatiAY/1TQve0CJWqJXNroh2ru66DfPkTdmg+2igrhQ7s4fBuwIDAQAB
# o4HbMIHYMDQGCCsGAQUFBwEBBCgwJjAkBggrBgEFBQcwAYYYaHR0cDovL29jc3Au
# dmVyaXNpZ24uY29tMBIGA1UdEwEB/wQIMAYBAf8CAQAwQQYDVR0fBDowODA2oDSg
# MoYwaHR0cDovL2NybC52ZXJpc2lnbi5jb20vVGhhd3RlVGltZXN0YW1waW5nQ0Eu
# Y3JsMBMGA1UdJQQMMAoGCCsGAQUFBwMIMA4GA1UdDwEB/wQEAwIBBjAkBgNVHREE
# HTAbpBkwFzEVMBMGA1UEAxMMVFNBMjA0OC0xLTUzMA0GCSqGSIb3DQEBBQUAA4GB
# AEpr+epYwkQcMYl5mSuWv4KsAdYcTM2wilhu3wgpo17IypMT5wRSDe9HJy8AOLDk
# yZNOmtQiYhX3PzchT3AxgPGLOIez6OiXAP7PVZZOJNKpJ056rrdhQfMqzufJ2V7d
# uyuFPrWdtdnhV/++tMV+9c8MnvCX/ivTO1IbGzgn9z9KMIIEAzCCAuugAwIBAgIK
# FRnzXQABAAAFZjANBgkqhkiG9w0BAQUFADA/MRIwEAYDVQQKEwlEZWxsIEluYy4x
# KTAnBgNVBAMTIERlbGwgSW5jLiBFbnRlcnByaXNlIElzc3VpbmcgQ0EyMB4XDTEy
# MDEyMDIzMzI0NFoXDTE0MDEyMDIzNDI0NFowZzELMAkGA1UEBhMCVVMxDjAMBgNV
# BAgTBVRleGFzMRMwEQYDVQQHEwpSb3VuZCBSb2NrMRIwEAYDVQQKEwlEZWxsIElu
# Yy4xCzAJBgNVBAsTAlBHMRIwEAYDVQQDEwlEZWxsIEluYy4wgZ8wDQYJKoZIhvcN
# AQEBBQADgY0AMIGJAoGBAMw7+ab05E5WD5dJuRvgdvgUGFoBPDnO0wVhvV2ZKSAW
# ppuQVyCSfdxcyf9FwpUBXpvImhNDIBuo1fCqh3ze70HiaUTZqa9aY3ea8acjzvj5
# bjP6t2f+Al6+JZFRPfJZ3Ewrs0ixkwpWE3J2AKo+4f5d3JRmqEUt9AdhRFuCwUYh
# AgMBAAGjggFbMIIBVzA9BgkrBgEEAYI3FQcEMDAuBiYrBgEEAYI3FQiHuNlsgYT4
# CIa9jQ+F84A1grOZWjOFw+1fha/BGgIBZAIBEzATBgNVHSUEDDAKBggrBgEFBQcD
# AzALBgNVHQ8EBAMCB4AwGwYJKwYBBAGCNxUKBA4wDDAKBggrBgEFBQcDAzAdBgNV
# HQ4EFgQU1yEh43ddMY3PSBS/tpovbGDSdP4wHwYDVR0jBBgwFoAUMpJnDP5UbwNQ
# dJbyV6qxP6PW498wRQYDVR0fBD4wPDA6oDigNoY0aHR0cDovL2RlbGxpbmNjYS5k
# ZWxsLmNvbS9jcmwvZXh0ZXJuYWxpc3N1aW5nY2EyLmNybDBQBggrBgEFBQcBAQRE
# MEIwQAYIKwYBBQUHMAKGNGh0dHA6Ly9kZWxsaW5jY2EuZGVsbC5jb20vYWlhL2V4
# dGVybmFsaXNzdWluZ2NhMi5jcnQwDQYJKoZIhvcNAQEFBQADggEBAJFeJo20Gwqq
# hCKnBljwOab2AseoHEOch0gykI+KjDeNjHaLQixmbxQ10xUFJEP66TDRDktf17g8
# zlDD0Do7w0GEZMyCwI0DXseqzHtq4sZU/ry3aVoFwsFVw35PnMHAEfCJu3QMPhfz
# cNYStAnveBr+fo3r3Y/GpowjUKEf+JZmig0ebXsxIlx+cHJXpfESfcre7VuLFzAD
# /r9MEOpdP4TG2laILmf4NRsCd9tWD83Jsz/7agbfY5HTXrh2WfCiUkM+jIFNI7Ph
# Ja5PBPxUF0/86AULsylGbB40a3MHb1mHJh27n8aYveIOz79JBZijxszW1yBuDVUV
# VMrm5X5h18owggRhMIIDSaADAgECAgoQT0cbAAAAAAAcMA0GCSqGSIb3DQEBBQUA
# MDYxEjAQBgNVBAoTCURlbGwgSW5jLjEgMB4GA1UEAxMXRGVsbCBJbmMuIEVudGVy
# cHJpc2UgQ0EwHhcNMTIwMTE5MjAwMzExWhcNMTcwMTE5MjAxMzExWjA/MRIwEAYD
# VQQKEwlEZWxsIEluYy4xKTAnBgNVBAMTIERlbGwgSW5jLiBFbnRlcnByaXNlIElz
# c3VpbmcgQ0EyMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEApu2QPJdr
# e6YqyveT62gyb1bUEDkdwPLySH3BMzvD8GFfaI7Csz3FKAI6z8Kt10lZHgXyM5Mr
# BNcxKnoqUyE8CpvG/zesxzb7qBbt9ftl8bMw9fiwMPGVBh/MMgWpB8LUC5w1WHRg
# FXnxkRZoZ7GgkxyD0T3z0slJXfWlGS6jX5tJmfpIg4MEIptS6yIDz0u8Im2vtYQB
# 214VxFvjVCGGgcg0juR3cgaP2cKmdz8O26HoouNLcrM2FJ6KTr1tf1xl/McL47UB
# jy6Rha/lROUUDSKcP6aodArMpxM5h3s7ud8Q6CaEXOWrkJsWYKF/Vk4ZeID6adtD
# rF2ztMj01xfM5wIDAQABo4IBZjCCAWIwEAYJKwYBBAGCNxUBBAMCAQEwIwYJKwYB
# BAGCNxUCBBYEFHEuxJ/8wHvs3FehMkc7KyDdCetXMB0GA1UdDgQWBBQykmcM/lRv
# A1B0lvJXqrE/o9bj3zAZBgkrBgEEAYI3FAIEDB4KAFMAdQBiAEMAQTALBgNVHQ8E
# BAMCAYYwEgYDVR0TAQH/BAgwBgEB/wIBADAfBgNVHSMEGDAWgBSkZiEOAUG49enx
# ccbQONIFNWmqEzBQBgNVHR8ESTBHMEWgQ6BBhj9odHRwOi8vZGVsbGluY2NhLmRl
# bGwuY29tL2NybC9EZWxsJTIwSW5jLiUyMEVudGVycHJpc2UlMjBDQS5jcmwwWwYI
# KwYBBQUHAQEETzBNMEsGCCsGAQUFBzAChj9odHRwOi8vZGVsbGluY2NhLmRlbGwu
# Y29tL2NybC9EZWxsJTIwSW5jLiUyMEVudGVycHJpc2UlMjBDQS5jcnQwDQYJKoZI
# hvcNAQEFBQADggEBAD6tx/nt+wm2XPwCjqHgewu8VMuoz9gMDsxCm/njpUS6GTzX
# 6TYtiLuumqFY8H72V4ABr6qsKUOMDRTVtQrVwZk1ucglTNXZMEp3MsxeuvHqTVLi
# v2Bv0mqkeO2tsC6g1YO11gK/elH+CAYDLRdf2R3yh7yOYiH8OvdBmcId7s5Y8U0q
# q0z9VZRP7rOIthVP/1gwYSGRHoNBmZNEP1QNc/0NxNRpa5CYh7dOVxn90ghHd7ly
# rgz/D1XGbYX9a15uDitPcQA8uQH9/DqEjyixvJNIhE+lKonRpxvJY5xSfkg9Q1kT
# fiHUbY7E3uJEogeLcwfGkrorgDESQElV9N7NboowggSiMIIEC6ADAgECAgQEAAOu
# MA0GCSqGSIb3DQEBBQUAMHUxCzAJBgNVBAYTAlVTMRgwFgYDVQQKEw9HVEUgQ29y
# cG9yYXRpb24xJzAlBgNVBAsTHkdURSBDeWJlclRydXN0IFNvbHV0aW9ucywgSW5j
# LjEjMCEGA1UEAxMaR1RFIEN5YmVyVHJ1c3QgR2xvYmFsIFJvb3QwHhcNMDQxMTE3
# MTUyNTAwWhcNMTgwODEzMjM1OTAwWjA2MRIwEAYDVQQKEwlEZWxsIEluYy4xIDAe
# BgNVBAMTF0RlbGwgSW5jLiBFbnRlcnByaXNlIENBMIIBIjANBgkqhkiG9w0BAQEF
# AAOCAQ8AMIIBCgKCAQEAnM1ho8e+Ih8de6SN1pcHRZhBVky9hHqMakUDZ1bp/NfI
# 6lZyNmAOQNZ0SWYyCJS5lVm3INAjNqopgZmztppLCExtNoEHE3JTIj6nFPPx7cmj
# u3Fv0bk7fQ+H99QCdiCH12IMAV8H57z2ppnstL+U0LR1r04KbxKwyo+xo+2LFh70
# JVqYQ73OhcCCC3D3E1brwyxTqNoL+cFXnPyfWN/H8jb14cIh5ZXVrn/MnbxaOS47
# 58edL+ggVX6QzgZZ1opNbukd/kA4eibpxfyH8NmKAl7V+9n/6ZKM8uvt+lQv6vkD
# n5kiFSM/Olb3j5Az6NI4sadNxMFAjVYseccuz6YaPwIDAQABo4IB+DCCAfQwRQYD
# VR0fBD4wPDA6oDigNoY0aHR0cDovL3d3dy5wdWJsaWMtdHJ1c3QuY29tL2NnaS1i
# aW4vQ1JMLzIwMTgvY2RwLmNybDAdBgNVHQ4EFgQUpGYhDgFBuPXp8XHG0DjSBTVp
# qhMwgdsGA1UdIASB0zCB0DBIBgkrBgEEAbE+AQAwOzA5BggrBgEFBQcCARYtaHR0
# cDovL3d3dy5wdWJsaWMtdHJ1c3QuY29tL0NQUy9PbW5pUm9vdC5odG1sMIGDBgwr
# BgEEAYUiAQUABQEwczA3BggrBgEFBQcCAjArGilEZWxsIEluYy4gQ2VydGlmaWNh
# dGUgUHJhY3RpY2VzIFN0YXRlbWVudDA4BggrBgEFBQcCARYsaHR0cDovL2RlbGxp
# bmNjYS5kZWxsLmNvbS9jcHMvZGVsbGluY2Nwcy5odG0wgYkGA1UdIwSBgTB/oXmk
# dzB1MQswCQYDVQQGEwJVUzEYMBYGA1UEChMPR1RFIENvcnBvcmF0aW9uMScwJQYD
# VQQLEx5HVEUgQ3liZXJUcnVzdCBTb2x1dGlvbnMsIEluYy4xIzAhBgNVBAMTGkdU
# RSBDeWJlclRydXN0IEdsb2JhbCBSb290ggIBpTAOBgNVHQ8BAf8EBAMCAeYwEgYD
# VR0TAQH/BAgwBgEB/wIBATANBgkqhkiG9w0BAQUFAAOBgQBrXtT5O0mqZX/y0VtX
# PCdoTUrnh1bvrBhQV8AXkHFiOQ8/PHP4rGnBZ5Op2rPNt5KLLHTH0VaTqOISBfkJ
# 5WGeDcyxbAWYwaAP3HkQSf0+RL24HnSONZx2bmASvL0J0Xo+6u4p3Y/HUadYnLBH
# W6i9h0sxcpakZEw5AQtXnvA4NjGCAvAwggLsAgEBME0wPzESMBAGA1UEChMJRGVs
# bCBJbmMuMSkwJwYDVQQDEyBEZWxsIEluYy4gRW50ZXJwcmlzZSBJc3N1aW5nIENB
# MgIKFRnzXQABAAAFZjAJBgUrDgMCGgUAoHgwGAYKKwYBBAGCNwIBDDEKMAigAoAA
# oQKAADAZBgkqhkiG9w0BCQMxDAYKKwYBBAGCNwIBBDAcBgorBgEEAYI3AgELMQ4w
# DAYKKwYBBAGCNwIBFTAjBgkqhkiG9w0BCQQxFgQUha/0eXOxqKWnuiPJm5DV5nxN
# V9owDQYJKoZIhvcNAQEBBQAEgYA0iY3QIjC6Gqx+FGd1nFqdIrGV1neFSVTKys4a
# KiGRvCJ0s09JE1GL/D2sTlzcgx/tFPX8y29pz0q7aMYi5XQiNG4j0r3XU7JeA2ve
# uyz8RK3rXWab48RY/wCq/GiN8L57E1t6UHusqy/8TZyQgfbfLb2swb5bttc2iwm6
# B81wS6GCAX8wggF7BgkqhkiG9w0BCQYxggFsMIIBaAIBATBnMFMxCzAJBgNVBAYT
# AlVTMRcwFQYDVQQKEw5WZXJpU2lnbiwgSW5jLjErMCkGA1UEAxMiVmVyaVNpZ24g
# VGltZSBTdGFtcGluZyBTZXJ2aWNlcyBDQQIQeaKlhfnRFUIT2bg+9raN7TAJBgUr
# DgMCGgUAoF0wGAYJKoZIhvcNAQkDMQsGCSqGSIb3DQEHATAcBgkqhkiG9w0BCQUx
# DxcNMTIwOTI2MDc0NTU4WjAjBgkqhkiG9w0BCQQxFgQUxHgJUDXPgvAjct1LsPaO
# LqKWjLowDQYJKoZIhvcNAQEBBQAEgYBzHn679ytOzuidMOnhyXy5hktQh3q5Rgwy
# A79QelHi4FfBlPxunELReFCWnr4ZvYAu9Ff4g4av8ibNEMbaHwDQS48xXTPNn6+B
# cKF1457Bd3TvFnt3Xsgvde5rZwY8H3fVcvJAAcYXuYfc9Xz7x2MF+x4BoRlzVQyZ
# viTvhr3tQw==
# SIG # End signature block

