﻿Import-module operationsmanager
$fqdn = [System.Net.Dns]::GetHostByName(($env:computerName))
$computerName = $fqdn.HostName					
																
function createOverride{
param($discoveryName, $overrideMp, $parameter, $overrideValue)
$Discovery =  Get-SCOMDiscovery -Name $discoveryName
DiscoveryConfigurationOverride -overrideMp $overrideMp -Discovery $Discovery[0] -parameter $parameter -overrideValue $overrideValue
}

function DiscoveryConfigurationOverride{									
param($overrideMp, $Discovery, $parameter, $overrideValue)
$overrideName = $Discovery.Name + ".Override"
$override = New-Object Microsoft.EnterpriseManagement.Configuration.ManagementPackDiscoveryConfigurationOverride($overrideMp, $overrideName)
$Target = Get-SCOMClass -Name "Microsoft.SystemCenter.OOB.SMASHDevice"
$override.Discovery = $Discovery
$override.Module = $discovery.DataSource
$Override.Parameter = $parameter
$override.Value = $overrideValue
$override.Context = $Target
$overrideMp.Verify()
$overrideMp.AcceptChanges()
}

$mpID = "Dell.SMASH.OnDemandDiscovery.Override"
$mg = New-Object Microsoft.EnterpriseManagement.ManagementGroup($computerName)
$mpStore = New-Object Microsoft.EnterpriseManagement.Configuration.IO.ManagementPackFileStore
$overrideMp = New-Object Microsoft.EnterpriseManagement.Configuration.ManagementPack($mpID, $mpID, (New-Object Version(1, 0, 0)), $mpStore)

createOverride -discoveryName "Dell.SMASHDevice.Discovery" -overrideMp $overrideMp -parameter 'IntervalSeconds' -overrideValue 86400
$mg.ImportManagementPack($overrideMp)