param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$tejasIP)

#DelUserName='tejas\administrator'
#DelPwd='Dell_123$'
#$VMMServer='sccm'
#$UserName = 'tejas\administrator'
#$Password = 'Dell_123$'

# Create obj
Function Createcredobj($username, $passwd)
{

    try{
        $secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        # handling of exception and returning back is having some issues 
        #$errorMessage = $Error[0].exception
        if ($debug1 -eq 0)
        {
            write-host "inside catch"
        }
    }

    return $mycredsobj

}
# return 0: success
# return 1: can not have permission to write file
# return 2: Alredy console registerd
# return 3: file not found



$returnValue = @()
	try{
		    $Server = $ComputerName.Split('.')[0]
            # Create SCVMM Cred obj    
            $Credential = Createcredobj $DomainUsername $DelPwd
		    $msg=Invoke-Command -ComputerName $Server -Credential $Credential -ConfigurationName Microsoft.PowerShell32 -ScriptBlock { 
  
				$ErrorActionPreference = "stop"
				$file='consoleplugin.xml';
				$path=$(split-path $Env:SMS_ADMIN_UI_PATH)+'\'+$file;
				$value='https://' + $args[0] + '/tejasconsole'
				if(Test-Path $path) 
				{
					try
					{
						$data = [xml] (Get-Content $path)
						$uriAddress = $data.GetElementsByTagName("uri").InnerXML
						if(![string]::IsNullOrWhiteSpace($uriAddress)){
						 return 2;
						}
                        
                        $data.SelectSingleNode("//Settings/uri").InnerText = $value
						$data.Save($path)
						return 0;
					}
					catch [Exception]
					{
						return 1;
					}
				}
				else 
				{
					return 3;
				}

            }-Args $tejasFQDN -ErrorVariable errmsg  2>$null
switch ($msg){
			 0 {	$returnjson="Status:Successfully registered with SCCM server"
			 		$returnValue = $returnValue + "SUCCESS" 
			        $returnValue = $returnValue + $returnjson
			       
					break
				}
			
			 1 {	$returnjson="Status:User does not have permission,Code:-6"
			 		$returnValue = $returnValue + "FAIL" 
			        $returnValue = $returnValue + $returnjson
			        
					break
				}
			
			 2 {	$returnjson="Status:User not register,Code:-5"
			 		$returnValue = $returnValue + "FAIL"  
			        $returnValue = $returnValue + $returnjson
			        
					break}
			
			 3 {	$returnjson="Status:SCCM plugin is not install or its corrupt,Code:-28"
			 		$returnValue = $returnValue + "FAIL" 
			        $returnValue = $returnValue + $returnjson
			        
					break
				}

		default {   $returnjson="Status:"+$errmsg
					$returnValue = $returnValue + "FAIL"
                    $returnValue = $returnValue + $returnjson
                    
                    break
				}
			 }		
    }
catch [system.exception]
            {
                   $returnjson="Status:"+$_.Exception.Message
                   $returnValue = $returnValue + "FAIL"
                   $returnValue = $returnValue + $returnjson
                  
            }
			
return $returnValue

