param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$tejasIP)
$api = New-Object -comObject 'MOM.ScriptAPI'
$ApplianceIP = $tejasIP
Import-module operationsmanager
$fqdn = [System.Net.Dns]::GetHostByName(($env:computerName))
$computerName = $fqdn.HostName
function createOverride{
    param($monitorName, $overrideMp, $parameter, $overrideValue)
    $Monitors =  Get-SCOMMonitor -Name $monitorName
    monitorConfigurationOverride -overrideMp $overrideMp -Monitor $Monitors[0] -parameter $parameter -overrideValue $overrideValue
}

function monitorConfigurationOverride{                                                                                                                                              
    param($overrideMp, $Monitor, $parameter, $overrideValue)
    $Target = Get-SCOMClass -Name "Microsoft.SystemCenter.ManagementServer"
    $overrideName = $Monitor.name
    $override = New-Object Microsoft.EnterpriseManagement.Configuration.ManagementPackMonitorConfigurationOverride($overrideMp, $overrideName)             
    $override.Monitor = $Monitor
    $Override.Parameter = $parameter
    $override.Value = $overrideValue
    $override.Context = $Target
    $overrideMp.Verify()
    $overrideMp.AcceptChanges()
}

try
{
	#$hardwareLibPath  = "\\"+$tejasIP+"\usr\share\tomcatTejas\lclogs\scom\mg\DellManagementPacks\Library\Dell.Connections.HardwareLibrary.mp"
	#$server_sdk_path  = "\\"+$tejasIP+"\usr\share\tomcatTejas\lclogs\scom\mg\DellManagementPacks\Server Monitoring\Dell.Server.SDK.mp"
	#$InstallStatus1 = Import-SCManagementPack $hardwareLibPath
	#$InstallStatus  = Import-SCManagementPack $server_sdk_path  

    $mpID = "Dell.SDK.ApplianceIP.Override"    
    $mg = New-Object Microsoft.EnterpriseManagement.ManagementGroup($computerName)
    $mpStore = New-Object Microsoft.EnterpriseManagement.Configuration.IO.ManagementPackFileStore
    $overrideMp = New-Object Microsoft.EnterpriseManagement.Configuration.ManagementPack($mpID, $mpID, (New-Object Version(1, 0, 0)), $mpStore)
    createOverride -monitorName "Dell.SDK.OverrideApplianceIP.UMT" -overrideMp $overrideMp -parameter 'ApplianceIP' -overrideValue $ApplianceIP
    $mg.ImportManagementPack($overrideMp)
    return "SUCCESS";
}
catch [Exception]
 {
   return "FAIL";
 }

