param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$info)

############### CONSTANTS ###########################

set-variable -name Response_Success -value "SUCCESS" -option constant
set-variable -name Response_FAIL -value "FAIL" -option constant

############### CONSTANTS ###########################

## This script executes Invoke-CauRun command for specified cluster 

#$clusterFqdnName='NODECLUSTER' 
#$hotFixConfigFile='DELL_UPDATE_SUU.xml'
#$hotfixRootPath='\\192.168.10.29\smbdemo\Share\CAU_Updates'
# Create Credential obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

$debug1 = 1
$cauPluginName='Microsoft.HotfixPlugin'
$cmdSuccess ="Running"
$cmdFailed = "Failed"
# Return Value
$returnval = @()
#r630autoclus.tejd.bdcsv.lab,DELL_UPDATE_SUU.xml,\\config1vmm.tejd.bdcsv.lab\UPDATE\r630autoclus.tejd.bdcsv.lab\CAU_Updates
$clusterFqdnName=$info.split(",")[0]
$hotFixConfigFile=$info.split(",")[1]
$hotfixRootPath=$info.split(",")[2]

try
{
	$cred=Createcredobj $DomainUsername $DelPwd
	
	#$sblock = [scriptblock]::create("Invoke-CauRun -ClusterName $clusterFqdnName -Force -CauPluginName  $cauPluginName -CauPluginArguments @{ 'RequireSmbEncryption' = 'True'; 'DisableAclChecks' = 'True'; 'HotfixConfigFileName' = '$hotFixConfigFile'; 'HotfixRootFolderPath' = '$hotfixRootPath' } -MaxRetriesPerNode 3 -EnableFirewallRules;")
	$sblock = [scriptblock]::create("Invoke-CauRun -ClusterName $clusterFqdnName -Force -CauPluginName  $cauPluginName -CauPluginArguments @{ 'RequireSmbEncryption' = 'True'; 'DisableAclChecks' = 'True'; 'HotfixInstallerTimeoutMinutes' = '180'; 'HotfixConfigFileName' = $hotFixConfigFile; 'HotfixRootFolderPath' = $hotfixRootPath } -MaxRetriesPerNode 3 -EnableFirewallRules;")
	$result=start-job -scriptblock $sblock
	

	if($?)
	{
		if ($result.State -ne  $cmdFailed)
		{
			$returnJson="ID:"+$result.Id+",State:"+$result.State
			$returnval = $returnval + $Response_Success
			$returnval = $returnval + $returnJson
			#$returnval = $returnval + $result.Id
			#$returnval = $returnval + $result.State
		}
		else
		{	
			$returnJson="State:"+$result.State
			$returnval = $returnval + $Response_FAIL
			$returnval = $returnval + $returnJson
			#$returnval = $returnval + "-1"
			#$returnval = $returnval + $result.State
		}
	}
	else
	{	
		$returnval = $returnval + $Response_FAIL
		$returnval = $returnval + "Invoke-CauRun Operation Completed Unsuccessfully"
		#$returnval = $returnval + "-1"
		#$returnval = $returnval + "undefined"
	}
	
	if ($debug1 -eq 0)
	{
			write-host $result.State
			write-host $returnval
	}
	return $returnval
}
catch [exception]
{
		$returnval = $returnval + $Response_FAIL
		$returnval = $returnval + $Error[0].Exception
		
}
return $returnval



















	