
param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$serviceTag)


<#
$ComputerName = "sksccm.mydomain.com"
$DomainUsername = "mydomain\administrator"
$DelPwd = "Dell_123$"
$tejasFQDN = "tejas1137.mydomain.com"
$serviceTag ="8J4VC2S"
#>
# Create obj
Function Createcredobj($username, $passwd)
{

    try
    {
	 $secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}
Function CheckOSDStatus($ComputerName,$DomainUsername,$DelPwd,$serviceTag){

	#fetch the SCCM Site
	$sccmCred= Createcredobj $DomainUsername $DelPwd
	$retStatus= Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
                  $serviceTag= $args[2]
		          Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
	   	          $PSD = Get-PSDrive -PSProvider CMSite
	              if($PSD -eq $null){
			         New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[1]
			         $PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
			         $SiteCode= CD "$($PSDN):"
		          }else{
	                 $SiteCode= CD "$($PSD):"	
		          }
	              $VMMobj= Get-CMSite
                  if ( $VMMobj -ne $null )
                  {
                  	try{ 
				       $returnvalue = @()		       	
				       $site = $VMMobj.SiteCode
                       $ns="root\sms\site_"+$site

				       $queryString= "Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_iDRAC.ServiceTag= ""$serviceTag"""
					   $queryResults=Get-WMIObject -Query $queryString -Namespace $ns
				                if($queryResults -ne $null )
                        		{
					                foreach($queryResult in $queryResults)
                            		{
                                		$genObjs = $queryResult.SMS_R_SYSTEM ;

						                if ($genObjs  -ne $null)
                                		{
                                    		foreach ($queryRslt in $genObjs)
                                    		{
                                                #$queryRslt.Client=1
                                                #$queryRslt.OperatingSystemNameandVersion="10.2 MS"
                                        		[int]$clientPresent = $queryRslt.Client;
                                            	$osNameAndVersion = $queryRslt.OperatingSystemNameandVersion
                                            	if ($clientPresent -eq 1 -and (-not ([string]::IsNullOrEmpty($osNameAndVersion))))
                                            	{
                                             		$returnvalue = $returnvalue + "true"
													############### CONSTANTS ###########################
		
													set-variable -name Response_Success -value "SUCCESS" -option constant
													set-variable -name Response_FAIL -value "FAIL" -option constant
													set-variable -name Exception_Code -value 101 -option constant
													set-variable -name zeroguid -value "00000004-0000-0000-0000-000000000000" -option constant
													set-variable -name collectionNameAllSystems -value "All Systems" -option constant
													set-variable -name osNameVersionIndex -value "0,1,2,3,4,5,6,7,8,9" -option constant
													set-variable -name collectionNameImportDellServers -value "Dell Imported Servers" -option constant
													set-variable -name collectionNameAllDellLCControllers -value "All Dell Lifecycle Controller Servers" -option constant
													set-variable -name collectionCommentImportDellServers -value "All Dell PowerEdge servers discovered using Import Dell PowerEdge servers wizard" -option constant
													set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
													set-variable -name collectionNameRhel -value "managed dell lifecycle controller(rhel)" -option constant
													set-variable -name collectionNameEsxi -value "managed dell lifecycle controller(esxi)" -option constant
													set-variable -name osRhel -value "rhel" -option constant
													set-variable -name osEsxi -value "esxi" -option constant
													set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
													set-variable -name collectionNameOSDeployed -value "Managed Dell Lifecycle Controller(Windows OS Deployed)" -option constant
													set-variable -name collectionNameOSUnknown -value  "Managed Dell Lifecycle Controller(OS Unknown)" -option constant
													set-variable -name collectionCommentOSDeployed -value "All Dell PowerEdge 11G (and above) servers with Configuration Manager Client" -option constant
													set-variable -name collectionCommentOSUnknown -value "All Dell PowerEdge 11G (and above) servers without Configuration Manager Client"-option constant
													
													############### CONSTANTS ###########################
													
													function Write-Log
													{
														param (
															[Parameter(Mandatory)]
															[string]$Message,
													
															[Parameter()]
															[ValidateSet('1','2','3')]
															[int]$Severity = 1 ## Default to a low severity. Otherwise, override
														)
												
														$line = [pscustomobject]@{
															'DateTime' = (Get-Date -Format "yyyy-MM-dd HH:mm:ss:ffff")
															'Message' = $Message
														}
												
														## Ensure that $LogFilePath is set to a global variable at the top of script
														$line | Export-Csv -Path $LogFilePath -Append -NoTypeInformation
													}

													$logBasePath="$(split-path $Env:SMS_ADMIN_UI_PATH)";
													$logFilePath="OMIMSSC_Discovery.log"

													$global:LogFilePath = Join-Path $logBasePath $logFilePath

												   try{

													if (!(Test-Path $LogFilePath)) {
														
														$NewLogFile = New-Item $LogFilePath -Force -ItemType File
													  }

													else {
														# Nothing to see here yet.
														}
													 }catch{
														$tempPath =[System.IO.Path]::GetTempPath()
														$basePath = [io.path]::combine($tempPath + "Log")
														$logFile=  Join-Path $basePath  $logFilePath 
														[system.io.directory]::CreateDirectory($logFile)
														$LogFilePath=$logFile
													 }
													
													Write-Log -Message "--------------------------------------------------------------------------------------"
													Write-Log -Message "--------------------------------------------------------------------------------------"
													Write-Log -Message "Creation of collection after OSD of Server in SCCM started"
													Write-Log -Message "--------------------------------------------------------------------------------------"
													Write-Log -Message "--------------------------------------------------------------------------------------"
													Write-Log -Message "Initiate Collection Creation"
													#Step 11. Create Dell Collections
													#check if Collection $collectionNameAllDellLCControllers exists or not
													$retCode=$false	
													Write-Log -Message "Check if the collection All Dell LC Controllers exist"
													$collName=$collectionNameAllDellLCControllers
													
													$collName=$collName.Replace("\","\\")
													$collName=$collName.Replace("'","\'")
													
													$queryString="Select * from SMS_Collection WHERE Name='$collName'"
													$collResult=Get-WMIObject -Query $queryString -Namespace $ns
													
													if($collResult -ne $null ){
															
														foreach($row in $collResult){
															$parentColl=$row.CollectionId
														}
														
														if(![string]::IsNullorEmpty($parentColl)){
														
															Write-Log -Message "Check if the Collection Managed Dell Lifecycle Controller (OS Deployed) is present"
															$collExist=$false
															$query="Select * from SMS_Collection WHERE Name='$collectionNameOSDeployed'"
															$result = Get-WMIObject -query $query -namespace $ns
															
															if($result -ne $null){
																$collExist=$true
															}
															
															if(!$collExist){
																Write-Log -Message "Create new SMS_Collection object"
																$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
																$CMCollection.Name=$collectionNameOSDeployed
																$CMCollection.Comment=$collectionCommentOSDeployed
																$CMCollection.OwnedByThisSite=$true
																$CMCollection.LimitToCollectionID=$parentColl
																$CMCollection.Put()
																$CMCollection.Get()
																
																$validateQuery="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_SYSTEM.Client=1"
																$ruleName="11G_OS_Rule"
																
																$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $validateQuery
																if($ValidatingQuery -eq $null){
																	return "Status:$response_FAIL,Message:Validation of query failed"
																}
																
																Write-Log -Message "Create new Query Rule"
																$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
																$NewRule.QueryExpression=$validateQuery
																$NewRule.RuleName=$ruleName
																
											
																$CMCollection.CollectionRules    += $NewRule.psobject.baseobject
																$put                     		 = $CMCollection.Put()
																$refresh                         = $CMCollection.RequestRefresh()
																$retCode=$true					
															}
														}
													}
													else
													{
														Write-Log -Message "The collection collectionName All Dell LC Controllers does not exist"
														
														$retCode = $false
														$parentColl = ""
														$queryString = "Select * from SMS_R_iDRAC"
														$collFound = $false
														$MAXRETRIES = 1
														$ctr = 0
												
												
														while($ctr -lt $MAXRETRIES -and $collFound -eq $false){ 
															$ctr=$ctr+1
														
															$result=Get-WMIObject -Query $queryString -Namespace $ns
														
														
															if($result -ne $null)
															{
																$collFound = $true
															}
														

															Write-Log -Message "Create the Collcetion Dell Lifecycle Controllers"
															$limitToCollectionID="SMS00001"
															$ownedByThisSite=$true
															$query="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME)"
															$ruleName= "11G_Parent_Rule"
															$validateQuery=$true
															
															Write-Log -Message "Create new SMS_Collection object"
															$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
															$CMCollection.Name=$collectionNameAllDellLCControllers
															$CMCollection.Comment=$collectionCommentAllDellLCControllers
															$CMCollection.OwnedByThisSite=$ownedByThisSite
															$CMCollection.LimitToCollectionID=$limitToCollectionID
															$didCommit=$CMCollection.Put()
															$CMCollection.Get()


												
															#validate
															if($validateQuery -eq $true){
																Write-Log -Message "Validate Query syntax"  
																$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $query
																if($ValidatingQuery -eq $null){
																	return "Status:$response_FAIL,Message:Validation of query failed"
																}
															}
															
															Write-Log -Message "Create new Query Rule"
															$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
															$NewRule.QueryExpression=$query
															$NewRule.RuleName=$ruleName
															

															$CMCollection.CollectionRules    += $NewRule.psobject.baseobject
															$put                             = $CMCollection.Put()
															$refresh                         = $CMCollection.RequestRefresh()
															$retCode=$true


															
															if($retCode -eq $true)
															{
																#get Collection ID
																$queryCollectionId="Select CollectionID from SMS_Collection WHERE Name='$collectionNameAllDellLCControllers'"
																$collectionID=Get-WMIObject -Query $queryCollectionId -Namespace $ns
																

																if($collectionId -eq $null){
																	Write-Log -Message "Unable to retrieve collection ID for Name='$collectionNameAllDellLCControllers'"
																	return "Unable to retrieve collection ID for collectionName All Dell LC Controllers"
																}else{
																	foreach($id in $collectionId){
																		$parentColl=$id.CollectionID
																	}
																}
																

																if(![string]::IsNullOrEmpty($parentColl)){
																	Write-Log -Message "Check if the Collection Managed Dell Lifecycle Controller (OS Deployed) is present"
																	$collExist=$false
																	$query="Select * from SMS_Collection WHERE Name='$collectionNameOSDeployed'"
																	$result = Get-WMIObject -query $query -namespace $ns
																	
																	if($result -ne $null){
																		$collExist=$true
																	}
																	
																	if(!$collExist)
																	{
																		Write-Log -Message "create new SMS_Collection object"
																		$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
																		$CMCollection.Name=$collectionNameOSDeployed
																		$CMCollection.Comment=$collectionCommentOSDeployed
																		$CMCollection.OwnedByThisSite=$true
																		$CMCollection.LimitToCollectionID=$parentColl
																		$CMCollection.Put()
																		$CMCollection.Get() 
																		
																		$validateQuery="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_SYSTEM.Client=1"
																		$ruleName="11G_OS_Rule"
																		
																		$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $validateQuery
																		if($ValidatingQuery -eq $null){
																			return "Status:$response_FAIL,Message:Validation of query failed"
																		}
																		
																		Write-Log -Message "Create new Query Rule" 
																		$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
																		$NewRule.QueryExpression=$validateQuery
																		$NewRule.RuleName=$ruleName
																		
													
																		$CMCollection.CollectionRules    += $NewRule.psobject.baseobject
																		$put                             = $CMCollection.Put()
																		$refresh                         = $CMCollection.RequestRefresh()
																		$retCode=$true
																								
																	}
																}
															}
														}
																			
													}
													Write-Log -Message "--------------------------------------------------------------------------------------"
													Write-Log -Message "--------------------------------------------------------------------------------------"
													Write-Log -Message "OSD of Server in SCCM Finished"
													Write-Log -Message "--------------------------------------------------------------------------------------"
													Write-Log -Message "--------------------------------------------------------------------------------------"
                                        				
												}
											}
										}
									}
								}
                        		else{             
                            		$returnvalue =  $returnvalue + "false"
                        		}
                     }catch{
                            $returnvalue =  $returnvalue + "false"
 
                     }
            
                  }else{
                           $returnvalue= $returnvalue+ "false"
                  } 
                  return $returnvalue 
	}-Args $DomainUsername,$ComputerName,$serviceTag -ErrorVariable errmsg  2>$null
       return $retStatus
}

[int] $trackingcount = 0;
[int] $WINDOWS_OSD_POLLING_COUNT = 65;
$osdstatus=@()
$returnvalue2=@()

        while ($trackingcount -lt $WINDOWS_OSD_POLLING_COUNT)
            {
                
                $osdStatus = CheckOSDStatus $ComputerName $DomainUsername $DelPwd $serviceTag
                #write-host $osdStatus
                if ($osdstatus -eq "true"){
                    break;
                 }
                $trackingcount++;
                Start-Sleep -s 60
            }

            if ($osdstatus -eq "true")
            {
				$returnvalue2  = $returnvalue2 + "SUCCESS" 
                $returnvalue2 =$returnvalue2 + "Windows Operating System Deployment completed successfully"

            }
            else
            {
                $returnvalue2  = $returnvalue2 + "FAIL" 
				$returnvalue2 =$returnvalue2 + "Failed to Deploy Windows Operating System"
            }

return $returnvalue2;