param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$SmBiosGuid)
 
 
<#
$WimPath="\\100.96.32.56\wim\boot.wim"
$DelPwd="Dell_123$"
$DelUserName="mydomain\administrator"
$VMMServerHost="sksccm.mydomain.com"
$CustomIsoName="hello.wim"
#>

$WimPath=$SmBiosGuid.split(",")[1]
$CustomIsoName=$SmBiosGuid.split(",")[0]	

############### CONSTANTS ###########################




Function GetADKPath($arg){
$ADKPATH= @()
$ErrorActionPreference = "stop"


Try {

     $ADKPATH =(Get-ItemProperty -Path 'HKLM:\SOFTWARE\WOW6432Node\Microsoft\Windows Kits\Installed Roots' -Name "KitsRoot10").KitsRoot10

}

Catch [System.Management.Automation.PSArgumentException]

{

      Try {

           $ADKPATH = (Get-ItemProperty -Path 'HKLM:\SOFTWARE\Microsoft\Windows Kits\Installed Roots' -Name "KitsRoot81").KitsRoot81 

        }

        Catch [System.Management.Automation.PSArgumentException]

        {


              Try {

                $ADKPATH = (Get-ItemProperty -Path 'HKLM:\SOFTWARE\Microsoft\Windows Kits\Installed Roots' -Name "KitsRoot").KitsRoot 

                }

                Catch [System.Management.Automation.PSArgumentException]

                 {

                   $ADKPATH ="ADK not installed"
  
  
                }
  
  
        }
  
 }


Finally { $ErrorActionPreference = "Continue" }

return $ADKPATH
}






Function  orchestrateWorkflow($VGSharePath)
{
    $VGSharePath =[System.IO.Path]::GetDirectoryName($WimPath)
    $ISOSharePath = ""
    $wimFolderName = "";
    $batchFileForEnvSetting = ""
    $ISOSharePath = Join-Path $VGSharePath "ISO\"
    $timeStamp = Get-Date -format  "yyyyMMddHHmmssfff"
    $full_WINPEENVPath = $timeStamp + $_WINPEENV

    write-host "ISOSharePath:"  $ISOSharePath
    write-host "Full WINPE ENV Path: "  $full_WINPEENVPath
    write-host 
    
            try
            {

 
                if (![System.IO.Directory]::Exists($ISOSharePath))
                {
                     [system.io.directory]::CreateDirectory($ISOSharePath)
                }
                $WIMSharePath = $VGSharePath
                write-host "WIM Share Path" $WIMSharePath
                if (![System.IO.Directory]::Exists($WIMSharePath))
                {
                    write-host "WIM share doesn't exist in the system"
                    return $WIM_SHARE_DOES_NOT_EXIST;
                }

    
                #Code change to support WAIK
                $fullPath = ""
                write-host "ToolKit Path: "  $ToolKitPath
                if ($ToolKitPath.ToUpper().contains("AIK"))
                {
                    $fullPath = [io.path]::combine($ToolKitPath, $WAIK_PREINSTALLATION_ENV)
                }
                Elseif ( ! [System.IO.file]::Exists([io.path]::combine($ToolKitPath,  $fullPathToDandISetEnv)))
                {
                    write-host """"  $ToolKitPath  $fullPathToDandISetEnv  """"
                    write-host "ADK not Installed"
                    return $ADK_NOT_INSTALLED;
                }
                if (!$ToolKitPath.ToUpper().contains("AIK"))
                {
                    #$batchFileForEnvSetting = $DOUBLE_QUOTE + $ToolKitPath + $fullPathToDandISetEnv + $DOUBLE_QUOTE;
                    

                    #$command1 = $DOUBLE_QUOTE + $ToolKitPath + $WINS_PREINSTALLATION_ENV + "copype.cmd" + $DOUBLE_QUOTE + " x86 " + $DOUBLE_QUOTE + $ISOSharePath + $full_WINPEENVPath + $DOUBLE_QUOTE;
                     
                    


                    $batchFileForEnvSetting = $DOUBLE_QUOTE + $ToolKitPath + $fullPathToDandISetEnv + $DOUBLE_QUOTE;
                    write-host "batchFile For Env Setting: " + $batchFileForEnvSetting
        
                    $command1 = $DOUBLE_QUOTE + $ToolKitPath + $WINS_PREINSTALLATION_ENV + "copype.cmd" + $DOUBLE_QUOTE + " AMD64 " + $DOUBLE_QUOTE + $ISOSharePath + $full_WINPEENVPath + $DOUBLE_QUOTE;
                    write-host "Command 1: "  $command1
                    
                    ProcessRunner $command1 $batchFileForEnvSetting

                    $command2 =Join-Path $ISOSharePath $full_WINPEENVPath | Join-Path -ChildPath $WINPEENV_WIM_FILE_PATH | Join-Path -ChildPath "Boot.wim"

                    write-host "Command 2: "  $command2
                    

                    if ([System.IO.Directory]::Exists($command2) -or [System.IO.file]::Exists($command2 ))
                    {
                        [System.IO.File]::Delete($command2);
                        write-host "Delete file : " + $command2
                    }
                    else
                    {
                        write-host "File did not exist :" + $command2
                        return $COPYPE_CMD_UNSUCCESSFULL;
                    }
                }

                 $extn= $CustomIsoName.Substring($CustomIsoName.length - $isoExtn.length);

                if($extn.toLower().equals($isoExtn.toLower()) -or $extn.toLower().equals($WIMEXTN.toLower()) ){
       
                    $updatedWimFolderName = $CustomIsoName.Remove($CustomIsoName.Length - $isoExtn.Length, $isoExtn.Length);
                }                    
                else
                {
                    $updatedWimFolderName = $CustomIsoName;
                }

                write-host "updated Wim Folder Name: " $updatedWimFolderName
                $pt=Join-Path $WIMSharePath $updatedWimFolderName | Join-Path -ChildPath "Boot.wim" 

                write-host "wim path : " $pt
                if ([System.IO.file]::Exists($pt))
                {
                    write-host "WIM file exists in WIM share"
                }
                else
                {
                    write-host "WIM file does not exists in WIM share "  $WIMSharePath "\" $updatedWimFolderName + "\\Boot.wim"
                    return $WIM_FILE_DOES_NOT_EXIST_IN_WIM_SHARE;
                }
                #Supporting for SCCM .wim bootimage, copy to wimShare itself
                write-host $extn
                if ($extn -ieq  $isoExtn)
                {
                    #File.Copy(WIMSharePath + wimFolderName + "\\Boot.wim", ISOSharePath + full_WINPEENVPath + "\\" + WINPEENV_WIM_FILE_PATH + "Boot.wim", true);
                    $sr = Join-Path $WIMSharePath  $updatedWimFolderName | Join-Path -ChildPath "Boot.wim"
                    $ds = Join-Path $ISOSharePath $full_WINPEENVPath | Join-Path -ChildPath $WINPEENV_WIM_FILE_PATH | Join-Path -ChildPath "Boot.wim"
                    write-host "Source Path: "  $sr
                    write-host "Dest Path: "  $ds
                    Copy-Item $sr $ds

                    write-host "Copying of wim path : " $ds
                    if (![System.IO.file]::Exists($ds))
                    {
                       write-host "Copying of WIM file failed"
                       return $COPYING_WINPE_WIM_FILE_FAILED;
                    }
                    $pt=Join-Path $ISOSharePath $full_WINPEENVPath | Join-Path -ChildPath "media\Boot\bootfix.bin"
                    write-host "deleting of wim path : " $pt
                    if ([System.IO.file]::Exists($pt))
                    {
                        write-host "deleting file : "  $ISOSharePath  $full_WINPEENVPath + "media\Boot\bootfix.bin"
                        [System.IO.file]::Delete($pt)
                    }

                     $ISOFileName = $CustomIsoName
					 $efisrc=Join-Path $ToolKitPath "Assessment and Deployment Kit\Deployment Tools\amd64\Oscdimg" | Join-Path -ChildPath "efisys_noprompt.bin" 
                     $efidst=Join-Path $ISOSharePath $full_WINPEENVPath | Join-Path -ChildPath "fwfiles\efisys.bin"
                     write-host "EFI Src" $efisrc
                     write-host "EFI dest " $efidst
                     copy $efisrc $efidst
                     $efisysPath = $DOUBLE_QUOTE + $ISOSharePath + $full_WINPEENVPath + "\fwfiles\Efisys.bin" +$DOUBLE_QUOTE
                     $etfsboot = $DOUBLE_QUOTE + $ISOSharePath + $full_WINPEENVPath + "\fwfiles\etfsboot.com" +$DOUBLE_QUOTE 
                     write-host  $efisysPath $etfsboot
                    
                    $command5 = "Oscdimg -bootdata:2#p0,e,b$etfsboot#pEF,e,b$efisysPath -u1 -udfver102 " + $DOUBLE_QUOTE + $ISOSharePath + $full_WINPEENVPath + "\\media"" "+  $DOUBLE_QUOTE + $ISOSharePath + "\" + $ISOFileName + $DOUBLE_QUOTE;
                    write-host "Command 5: " $command5
                    ProcessRunner $command5 $batchFileForEnvSetting
                   

                    $isopath = $ISOSharePath + $ISOFileName;
                    write-host "Iso Path: " $isopath

                    if (![System.IO.File]::Exists($isopath))
                    {
                        write-host "ISO file doesn't exist isopath: "  $isopath
                        return $SCVMM_WINPE_ISO_CREATION_FAILED;
                    }
                }
                elseif ( $extn -ieq  $WIMEXTN )
                {
                    $sr=Join-Path $WIMSharePath  $updatedWimFolderName  | Join-Path -ChildPath "Boot.wim"
                    $ds=Join-Path $VGSharePath  $CustomIsoName 
                    write-host $sr  " -- " $ds
                    Copy-Item $sr $ds
                   
                    if (![System.IO.file]::Exists($ds))
                    {
                        write-host "WIM file doesn't exist isopath: " $WIMSharePath "\" $CustomIsoName
                        return $SCVMM_WINPE_ISO_CREATION_FAILED;
                    }
                }


                return $WINPE_ISO_CREATED_SUCCESSFULLY;
        }
        catch [system.exception]
        {
              write-host $_.Exception.Message
        }
        finally
        {
                write-host "Clear Folder..."
                $pt=Join-Path $ISOSharePath  $full_WINPEENVPath
                write-host $pt 
                if([System.IO.Directory]::Exists($pt))
                {
                    write-host "deleting directory("  $pt  ") and its contents"
                    #Directory.Delete(ISOSharePath + full_WINPEENVPath, true);
                    Remove-Item -Recurse -Force $pt
                    write-host "deleted dir"            
                }
                $customWimFolder=Join-Path $WIMSharePath $updatedWimFolderName
                if([System.IO.Directory]::Exists($customWimFolder))
                {
                    Remove-Item -Recurse -Force $customWimFolder
                    write-host "Deleted dir"            
                }
                $customISOFolder=Join-Path $WIMSharePath "ISO"
                if([System.IO.Directory]::Exists($customISOFolder))
                {
                   if((Get-ChildItem $customISOFolder -force | Select-Object -First 1 | Measure-Object).Count -eq 0)
                    {
                        Remove-Item -Recurse -Force $customISOFolder
                        write-host "Deleted dir"            
                    }
                   
                }

        }
    }

 # Create obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

Function ProcessRunner($command, $batchFileForEnvSetting)
{

    $psi = New-Object System.Diagnostics.ProcessStartInfo;
    $psi.FileName = "cmd.exe"; #process file
    $psi.UseShellExecute = $false; #start the process from it's own executable file
    $psi.RedirectStandardInput = $true; #enable the process to read from standard input
    $psi.RedirectStandardError = $true 
    $psi.RedirectStandardOutput = $true 

    $p = [System.Diagnostics.Process]::Start($psi);

    #Start-Sleep -s 2 #wait 2 seconds so that the process can be up and running
    write-host "--------"
    write-host $batchFileForEnvSetting
    write-host $command 

     if ($p -ne $null){
     $p.StandardInput.WriteLine($batchFileForEnvSetting)
     $p.StandardInput.WriteLine($command)
     $p.StandardInput.Close();
     #$output = $p.StandardError.ReadToEnd()
     $output = $p.StandardOutput.ReadToEnd() 
     write-host $output 
    }


}

$funDef = "function GetADKPath { ${function:GetADKPath} }; function orchestrateWorkflow { ${function:orchestrateWorkflow}}; function ProcessRunner { ${function:ProcessRunner}}"
$message=@()
$sccmCred= Createcredobj $DomainUsername $DelPwd
$message= Invoke-Command -ArgumentList ($funDef,$WimPath,$CustomIsoName) -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
           	 
            Param( $funDef,$WimPath,$CustomIsoName )

            . ([ScriptBlock]::Create($funDef))
           
           
            $operationName = "ADKPath";   
            $CMD_EXE = "cmd.exe"
            $DEPLOYMENT_TOOLS_PATH = "Assessment and Deployment Kit\\Deployment Tools\\"
            $fullPathToDandISetEnv = Join-Path $DEPLOYMENT_TOOLS_PATH "DandISetEnv.bat"
            $_WINPEENV = "_winpeenv";
            $DOUBLE_QUOTE = """"
            $WINS_PREINSTALLATION_ENV = "Assessment and Deployment Kit\\Windows Preinstallation Environment\\";
            $WAIK_PREINSTALLATION_ENV = "Tools\PETools\";
            $WINPEENV_WIM_FILE_PATH = "media\sources\";
            $isoExtn = ".iso";
            $WIMEXTN = ".wim";
            $returnValue=@()

            #constant

            $WINPE_ISO_CREATED_SUCCESSFULLY ="WINPE ISO created successfully"
            $ISO_SHARE_DOES_NOT_EXIST =  "ISO share doesn't exist in the system. Please check your VG installation"
            $WIM_SHARE_DOES_NOT_EXIST = "WIM share doesn't exist in the system. Please check your VG installation"
            $ADK_NOT_INSTALLED = "ADK not Installed"
            $COPYPE_CMD_UNSUCCESSFULL = "COPYPE was unsuccessfull."
            $COPYING_WINPE_WIM_FILE_FAILED = "Copying of WINPE WIM file failed"
            $SCVMM_WINPE_ISO_CREATION_FAILED = "WINPE ISO creation failed"
            $WIM_FILE_DOES_NOT_EXIST_IN_WIM_SHARE = "WIM file does not exist in WIM share"
            $SCCM_WINPE_WIM_CREATION_FAILED = "WINPE WIM creation failed"
            $ToolKitPath  = GetADKPath "DUMMY"

            $fqdUser = $DelUserName;
            $VGSharePath =[System.IO.Path]::GetTempPath()

            try{
                 $WINPEISOCREATION  = orchestrateWorkflow $VGSharePath

                 write-host $WINPEISOCREATION

                 if ($WINPEISOCREATION -eq $WINPE_ISO_CREATED_SUCCESSFULLY)
                 {
                    $returnValue= "SUCCESS"
                    
                 }
                 else
                 {
                     $returnValue= "FAIL"
                 }
                 
            }            
            catch [system.exception]
            {
                $returnValue= "FAIL"

            } 
            $returnValue= $returnValue+ $WINPEISOCREATION    
            return  $returnValue    

	}

$returnval2=@()
if($message -match "SUCCESS"){
    $returnval2=$returnval2+"SUCCESS"
    $returnval2=$returnval2+$message
    return $returnval2
}else{
    $returnval2=$returnval2+"FAIL"
    $returnval2=$returnval2+$message
    return $returnval2
}

