param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$SccmSmBiosGuid)


Function Createcredobj($username, $passwd){
    try{
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch{
        $mycredsobj = $null
    }

    return $mycredsobj
}



$SccmSmBiosGuid = $SccmSmBiosGuid -replace "\\n\\r", " "


$returnval = @()


$sccmCred= Createcredobj $DomainUsername $DelPwd

try{
	#step 1. Create connection with SCCM machine and get the site code
	$emsg=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
    
   	
		############### CONSTANTS ###########################
		
		set-variable -name Response_Success -value "SUCCESS" -option constant
		set-variable -name Response_FAIL -value "FAIL" -option constant
		set-variable -name Exception_Code -value 101 -option constant
		set-variable -name zeroguid -value "00000004-0000-0000-0000-000000000000" -option constant
		set-variable -name collectionNameAllSystems -value "All Systems" -option constant
		set-variable -name osNameVersionIndex -value "0,1,2,3,4,5,6,7,8,9" -option constant
		set-variable -name collectionNameImportDellServers -value "Dell Imported Servers" -option constant
		set-variable -name collectionNameAllDellLCControllers -value "All Dell Lifecycle Controller Servers" -option constant
		set-variable -name collectionCommentImportDellServers -value "All Dell PowerEdge servers discovered using Import Dell PowerEdge servers wizard" -option constant
		set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
		set-variable -name collectionNameRhel -value "managed dell lifecycle controller(rhel)" -option constant
		set-variable -name collectionNameEsxi -value "managed dell lifecycle controller(esxi)" -option constant
		set-variable -name osRhel -value "rhel" -option constant
		set-variable -name osEsxi -value "esxi" -option constant
		set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
		set-variable -name collectionNameOSDeployed -value "Managed Dell Lifecycle Controller(OS Deployed)" -option constant
		set-variable -name collectionNameOSUnknown -value  "Managed Dell Lifecycle Controller(OS Unknown)" -option constant
		set-variable -name collectionCommentOSDeployed -value "All Dell PowerEdge 11G (and above) servers with ConfigurationManager Client" -option constant
		set-variable -name collectionCommentOSUnknown -value "All Dell PowerEdge 11G (and above) servers without ConfigurationManager Client"-option constant
		
		############### CONSTANTS ###########################
		
		
		Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
	   	$PSD = Get-PSDrive -PSProvider CMSite
	    if($PSD -eq $null){
			New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[1]
			$PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
			$SiteCode= CD "$($PSDN):"
		}else{
	        $SiteCode= CD "$($PSD):"	
		}
	    $VMMobj= Get-CMSite
        if ( $VMMobj -ne $null ){
			
			$site=$VMMobj.SiteCode
	    }else{
			return "Site Code of the SC was not identified"
		}
		
		#Step 2. Split the smbios to get the machine information
		$nodeId=$args[2].split(",")[0]
		$serviceTag=$args[2].split(",")[1]
		$hostname=$args[2].split(",")[2]
		$model=$args[2].split(",")[3]
		$guid=$args[2].split(",")[4]
		$platformGuid=$args[2].split(",")[5]
		$macAddress=$args[2].split(",")[6].split("?")
		$ipsubnet=$args[2].split(",")[7]
		$osnames=$args[2].split(",")[8].split(":")
		$driverpackversion=$args[2].split(",")[9]
		$ipaddresses=$args[2].split(",")[10]
		
		$nonWindowsOSDeployed=$hostname
		
		#Step 3. Get the custom Collection Query id 
		[System.Guid] $guidObject = [System.Guid]::NewGuid()
		$customcollectionqueryid="dell_"+$guidObject.Guid
		
		$tempHostName=$hostname
		
		#Step 4. Find if the host exists
		$query="Select NETBIOSNAME from SMS_R_System where SMBIOSGUID='$guid'"
		$ns="root\sms\site_$site"
		
		$responses=Get-WMIObject -Query $query -Namespace $ns
        
		if(![string]::IsNullOrEmpty($guid) -or $guid -ne $zeroguid){
			if($responses -ne $null){
				#we found the host from sms_r_system
				foreach($response in $responses){
					$hostname=$response.NETBIOSNAME
				}
			}
		}else{
			$hostname=""
		}
		
		#Step 5. if the hostname was not found in sms_r_system then check if any row is available for temphostname
		
		if([string]::IsNullorEmpty($hostname)){
			$query="Select * from SMS_R_System where NETBIOSNAME='$tempHostName'"
			$responses=Get-WMIObject -Query $query -Namespace $ns
			
                    
			if($responses -ne $null){
				
				$hostname=$tempHostName
				
			}else{
				
				#Step 6. If the host occurence is not found in sms_r_system, then check if macadress is present in sms_r_system. 
				
				foreach($macadd in $macAddress){
					$query="Select NETBIOSNAME from SMS_R_SYSTEM where MACAddresses='$macadd'"
					$responses=Get-WMIObject -Query $query -Namespace $ns
					
 
					if($responses -ne $null){
						foreach($response in $responses){
							if(![string]::IsNullorEmpty($response.NETBIOSNAME)){
								$hostname=$response.NETBIOSNAME
							}else{
								$hostname=$serviceTag
							}
						}
					}
				}
				
				if([string]::IsNullorEmpty($hostname)){
					return "Status:FAIL,Message:The Host was not found"
				}
			}
			
		}
		
		#Step 7. Delete the old DDR
		#Start deleting the old DDR
		$queryDelIdrac="Select NetbiosName from SMS_R_iDRAC where SMBIOSGUID = '$guid'"
		$queryResultsforIdrac=Get-WMIObject -Query $queryDelIdrac -Namespace $ns
	
           
		if($queryResultsforIdrac -ne $null){
			foreach($queryResultforIdrac in $queryResultsforIdrac){
			
				$netbiosname=$queryResultforIdrac.NetbiosName
			
				$comp = [wmi]"\\.\root\sms\site_$siteCode:sms_r_idrac.NetbiosName=$($queryResultforIdrac.NetbiosName)"
				#delete the entry from SMS_R_iDRAC
				$comp.psbase.delete()
			
				if(![string]::IsNullOrEmpty($netbiosname)){
					$queryDelSystem="Select resourceID from SMS_R_System WHERE SMBIOSGUID = '$guid'"
					$queryResultsforSystem=Get-WMIObject -Query $queryDelSystem -Namespace $ns
				
					if($queryResultsforSystem -ne $null){
						foreach($queryResultforSystem in $queryResultsforSystem){
						
							$comp = [wmi]"\\.\root\sms\site_$($siteCode):sms_r_system.resourceID=$($queryResultforSystem.ResourceId)"
							#delete the entry from SMS_R_SYSTEM
							$comp.psbase.delete()
						}
					}else{
						#return "Status:$response_FAIL,Message:Unable to find idrac from SmbiosGUID in SMS_R_System"
					}
				}else{
					#return "Status:$response_FAIL,Message:Unable to find idrac from NetbiosName in SMS_R_IDRAC"
				}
			}
		}else{
			#return "Status:$response_FAIL,Message:Unable to find idrac from SmbiosGUID in SMS_R_IDRAC"
		}
		#Finished deleting the old DDR
		
		
	}-Args $DomainUsername,$ComputerName,$SccmSmBiosGuid -ErrorVariable errmsg  2>$null
	
	if($emsg -match "FAIL"){
		$returnval=$returnval+"FAIL"
		$returnval=$returnval+$emsg
		return $returnval
	}else{
	
		$returnval=$returnval+"SUCCESS"
		$returnval=$returnval+"DDR created successfully"
		return $returnval
	}
	
}catch{
	$returnval=$returnval+"FAIL"
	$returnval=$returnval+$_.Exception.Message
	return $returnval
}