param($consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP,$fileName)

$secpasswd = ConvertTo-SecureString $password -AsPlainText -Force
$mycreds = New-Object System.Management.Automation.PSCredential -argumentlist $domainUsername, $secpasswd

switch ($fileName)
{
	"console_type"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/ConsoleDetails.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"authenticate_user_scvmm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate  -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/AuthenticateUserSCVMM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"authenticate_user_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/AuthenticateUserSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"authenticate_user_scom"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/AuthenticateUserSCOM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"get_User_Role_SCVMM"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate  -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetUserRole.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"get_User_Role_SCCM"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetUserRoleSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"enroll_console_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate  -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/RegisterSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"enroll_console_scom"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate  -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/RegisterSCOM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"enroll_console_scvmm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate  -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/RegisterSCVMM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"deenroll_console_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate  -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/DeEnrollSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"deenroll_console_scvmm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/DeEnrollSCVMM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"add_ig_to_library"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate  -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/AddIGToLibrary.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"create_Run_As_Acc"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate  -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/CreateRunasacc.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"copyDriverToLibraryServer_FromStaging"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate  -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/CopyDriversToLibraryServerFromStaging.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"getHostBy_SMBIOS"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetHostBySMBIOS.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"get_Run_as_Acc"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetAllRunAsAcc.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"remove_Run_As_Acc"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/RemoveRunAsAcc.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"get_SCCM_Host"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetHostforSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"get_SCVMM_Host"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetAllHosts.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"delete_Ig_LibraryShare"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/DeleteIGLibraryShare.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"delete_DriverFromLibraryShare_SCVMM"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/DeleteDriverFolderFromLibraryServer.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"tag_drivers_addToHost"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/TagDriversAndAddToHostProfile.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"delete_host_Profile"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/DeleteHostProfile.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"remove_hostBy_SmBiosGuid_scvmm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/RemoveHostBySMBiosGuidFromSCVMM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"sccim_create_share"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/CreateCIMShare.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"sccim_remove_share"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/RemoveCIMSMBShare.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"winpe_isocreation_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/WinPEISOCreationSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"winpe_driverinjection_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/WinPEDriverInjectionSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"driver_injection"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/WinPEDriverinjection.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"driv_and_unmount"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/WinPEInjDrvAndUnmount.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"iso_creation"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/WinPEISOCreation.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}	
	"expand_cab_file"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/ExpandCabFile.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"get_cauUpdate_status"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetCauUpdateStatus.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"run_cauUpdate"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/CreateWinTask.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"get_cauUpdate_report"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetCauUpdateReport.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"generate_cauUpdate_report"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GenerateCauUpdateReport.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"cleanup_caurepository"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/CleanUpCauRepository.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"create_DDR_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/CreateDDRForSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"create_ddr_autodiscovery"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/CreateDDRinSCCmForAutoDiscovery.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"delete_hots_bysmbios"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetHostBySCCMSmbiosGuidForDelete.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"delete_ddr_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/DeleteDDRBySmbiosGuidSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"getsccmhost_autodiscovery"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetHostbySCCMSmbiosForAutoDiscovery.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"sccm_get_allhosts"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetAllSCCMHost.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"import_machine_entry"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/ImportMachineentry.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"pre_getHost_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/pre-GetHostForSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"post_getHost_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/post-GetHostForSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"pre_createddr_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/pre-CreateDDRForSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"post_createddr_sccm"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/post-CreateDDRForSCCM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
    	"get_sccm_task_sequence"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/SCCMGetTaskSequence.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
    	"get_sccm_windows_status"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/SCCMWindowsOSDStatus.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"scom_monitoring"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/Event-Generation.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"create_cau_share"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/CreateCAUShare.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"find_sc_computer"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/OSD-FindSCComputer.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"get_Job_Status"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetJobStatus.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"new_SCVM_Host"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/OSD-NewSCVMHost.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"gethost_profile_group"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetHostProfilesAndGroups.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"delete_Ig_LibraryShare"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/DeleteIGLibraryShare.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"sccm_isIG_running"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/SCCMCheckISIGRunning.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"sccm_create_non_windows_collection"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/CreateCollectionForNonWindowsOS.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"get_logical_switches"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetLogicalSwitchesFromSCVMM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"create_logical_networks"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/CreateLogicalNetworksForSCVMM.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
	"get_hostgroup_names"{Invoke-Command -ComputerName $consolefqdn -Credential $mycreds -Authentication Negotiate -ErrorAction SilentlyContinue -WarningAction SilentlyContinue -FilePath /usr/share/webapps/spectre/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/GetConsoleAllHostGroupNames.ps1 -ArgumentList $consolefqdn,$domainUsername,$password,$tejasFQDN,$tejasIP}
}